{-# OPTIONS_GHC -fno-warn-orphans -fno-warn-unused-imports #-}

-- Generated code.

{-# OPTIONS_GHC -fno-warn-unused-imports #-}

{-# LANGUAGE ForeignFunctionInterface, ConstraintKinds,
    TypeFamilies, MultiParamTypeClasses, KindSignatures,
    FlexibleInstances, UndecidableInstances, DataKinds,
    OverloadedStrings, NegativeLiterals, FlexibleContexts #-}

module GI.WebKit2Attributes where

import Prelude ()
import Data.GI.Base.ShortPrelude
import Data.Char
import Data.Int
import Data.Word
import qualified Data.ByteString.Char8 as B
import Data.ByteString.Char8 (ByteString)
import qualified Data.Map as Map
import Foreign.C
import Foreign.Ptr
import Foreign.ForeignPtr
import Foreign.ForeignPtr.Unsafe (unsafeForeignPtrToPtr)
import Foreign.Storable (peek, poke, sizeOf)
import Control.Applicative ((<$>))
import Control.Exception (onException)
import Control.Monad.IO.Class
import qualified Data.Text as T

import Data.GI.Base.Attributes hiding (get, set)
import Data.GI.Base.BasicTypes
import Data.GI.Base.BasicConversions
import Data.GI.Base.Closure
import Data.GI.Base.GError
import Data.GI.Base.GHashTable
import Data.GI.Base.GParamSpec
import Data.GI.Base.GVariant
import Data.GI.Base.GValue
import Data.GI.Base.ManagedPtr
import Data.GI.Base.Overloading
import Data.GI.Base.Properties hiding (new)
import Data.GI.Base.Signals (SignalConnectMode(..), connectSignalFunPtr, SignalHandlerId)
import Data.GI.Base.Utils

import qualified GI.Gdk as Gdk
import qualified GI.GdkAttributes as GdkA
import qualified GI.Gtk as Gtk
import qualified GI.GtkAttributes as GtkA
import qualified GI.Soup as Soup
import qualified GI.SoupAttributes as SoupA
import GI.WebKit2

type instance AttributeList AuthenticationRequest = '[ ]

type instance AttributeList BackForwardList = '[ ]

type instance AttributeList BackForwardListItem = '[ ]

-- VVV Prop "rgba"
   -- Type: TInterface "Gdk" "RGBA"
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getColorChooserRequestRgba :: (MonadIO m, ColorChooserRequestK o) => o -> m Gdk.RGBA
getColorChooserRequestRgba obj = liftIO $ getObjectPropertyBoxed obj "rgba" Gdk.RGBA

setColorChooserRequestRgba :: (MonadIO m, ColorChooserRequestK o) => o -> Gdk.RGBA -> m ()
setColorChooserRequestRgba obj val = liftIO $ setObjectPropertyBoxed obj "rgba" val

constructColorChooserRequestRgba :: Gdk.RGBA -> IO ([Char], GValue)
constructColorChooserRequestRgba val = constructObjectPropertyBoxed "rgba" val

data ColorChooserRequestRgbaPropertyInfo
instance AttrInfo ColorChooserRequestRgbaPropertyInfo where
    type AttrAllowedOps ColorChooserRequestRgbaPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint ColorChooserRequestRgbaPropertyInfo = (~) Gdk.RGBA
    type AttrBaseTypeConstraint ColorChooserRequestRgbaPropertyInfo = ColorChooserRequestK
    type AttrGetType ColorChooserRequestRgbaPropertyInfo = Gdk.RGBA
    type AttrLabel ColorChooserRequestRgbaPropertyInfo = "ColorChooserRequest::rgba"
    attrGet _ = getColorChooserRequestRgba
    attrSet _ = setColorChooserRequestRgba
    attrConstruct _ = constructColorChooserRequestRgba

type instance AttributeList ColorChooserRequest = '[ '("rgba", ColorChooserRequestRgbaPropertyInfo)]

type instance AttributeList ContextMenu = '[ ]

type instance AttributeList ContextMenuItem = '[ ]

type instance AttributeList CookieManager = '[ ]

-- VVV Prop "allow-overwrite"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDownloadAllowOverwrite :: (MonadIO m, DownloadK o) => o -> m Bool
getDownloadAllowOverwrite obj = liftIO $ getObjectPropertyBool obj "allow-overwrite"

setDownloadAllowOverwrite :: (MonadIO m, DownloadK o) => o -> Bool -> m ()
setDownloadAllowOverwrite obj val = liftIO $ setObjectPropertyBool obj "allow-overwrite" val

constructDownloadAllowOverwrite :: Bool -> IO ([Char], GValue)
constructDownloadAllowOverwrite val = constructObjectPropertyBool "allow-overwrite" val

data DownloadAllowOverwritePropertyInfo
instance AttrInfo DownloadAllowOverwritePropertyInfo where
    type AttrAllowedOps DownloadAllowOverwritePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DownloadAllowOverwritePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DownloadAllowOverwritePropertyInfo = DownloadK
    type AttrGetType DownloadAllowOverwritePropertyInfo = Bool
    type AttrLabel DownloadAllowOverwritePropertyInfo = "Download::allow-overwrite"
    attrGet _ = getDownloadAllowOverwrite
    attrSet _ = setDownloadAllowOverwrite
    attrConstruct _ = constructDownloadAllowOverwrite

-- VVV Prop "destination"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getDownloadDestination :: (MonadIO m, DownloadK o) => o -> m T.Text
getDownloadDestination obj = liftIO $ getObjectPropertyString obj "destination"

data DownloadDestinationPropertyInfo
instance AttrInfo DownloadDestinationPropertyInfo where
    type AttrAllowedOps DownloadDestinationPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DownloadDestinationPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DownloadDestinationPropertyInfo = DownloadK
    type AttrGetType DownloadDestinationPropertyInfo = T.Text
    type AttrLabel DownloadDestinationPropertyInfo = "Download::destination"
    attrGet _ = getDownloadDestination
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "estimated-progress"
   -- Type: TBasicType TDouble
   -- Flags: [PropertyReadable]

getDownloadEstimatedProgress :: (MonadIO m, DownloadK o) => o -> m Double
getDownloadEstimatedProgress obj = liftIO $ getObjectPropertyDouble obj "estimated-progress"

data DownloadEstimatedProgressPropertyInfo
instance AttrInfo DownloadEstimatedProgressPropertyInfo where
    type AttrAllowedOps DownloadEstimatedProgressPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DownloadEstimatedProgressPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DownloadEstimatedProgressPropertyInfo = DownloadK
    type AttrGetType DownloadEstimatedProgressPropertyInfo = Double
    type AttrLabel DownloadEstimatedProgressPropertyInfo = "Download::estimated-progress"
    attrGet _ = getDownloadEstimatedProgress
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "response"
   -- Type: TInterface "WebKit2" "URIResponse"
   -- Flags: [PropertyReadable]

getDownloadResponse :: (MonadIO m, DownloadK o) => o -> m URIResponse
getDownloadResponse obj = liftIO $ getObjectPropertyObject obj "response" URIResponse

data DownloadResponsePropertyInfo
instance AttrInfo DownloadResponsePropertyInfo where
    type AttrAllowedOps DownloadResponsePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DownloadResponsePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DownloadResponsePropertyInfo = DownloadK
    type AttrGetType DownloadResponsePropertyInfo = URIResponse
    type AttrLabel DownloadResponsePropertyInfo = "Download::response"
    attrGet _ = getDownloadResponse
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList Download = '[ '("allow-overwrite", DownloadAllowOverwritePropertyInfo), '("destination", DownloadDestinationPropertyInfo), '("estimated-progress", DownloadEstimatedProgressPropertyInfo), '("response", DownloadResponsePropertyInfo)]

-- VVV Prop "typing-attributes"
   -- Type: TBasicType TUInt32
   -- Flags: [PropertyReadable]

getEditorStateTypingAttributes :: (MonadIO m, EditorStateK o) => o -> m Word32
getEditorStateTypingAttributes obj = liftIO $ getObjectPropertyCUInt obj "typing-attributes"

data EditorStateTypingAttributesPropertyInfo
instance AttrInfo EditorStateTypingAttributesPropertyInfo where
    type AttrAllowedOps EditorStateTypingAttributesPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint EditorStateTypingAttributesPropertyInfo = (~) ()
    type AttrBaseTypeConstraint EditorStateTypingAttributesPropertyInfo = EditorStateK
    type AttrGetType EditorStateTypingAttributesPropertyInfo = Word32
    type AttrLabel EditorStateTypingAttributesPropertyInfo = "EditorState::typing-attributes"
    attrGet _ = getEditorStateTypingAttributes
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList EditorState = '[ '("typing-attributes", EditorStateTypingAttributesPropertyInfo)]

type instance AttributeList FaviconDatabase = '[ ]

-- VVV Prop "filter"
   -- Type: TInterface "Gtk" "FileFilter"
   -- Flags: [PropertyReadable]

getFileChooserRequestFilter :: (MonadIO m, FileChooserRequestK o) => o -> m Gtk.FileFilter
getFileChooserRequestFilter obj = liftIO $ getObjectPropertyObject obj "filter" Gtk.FileFilter

data FileChooserRequestFilterPropertyInfo
instance AttrInfo FileChooserRequestFilterPropertyInfo where
    type AttrAllowedOps FileChooserRequestFilterPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint FileChooserRequestFilterPropertyInfo = (~) ()
    type AttrBaseTypeConstraint FileChooserRequestFilterPropertyInfo = FileChooserRequestK
    type AttrGetType FileChooserRequestFilterPropertyInfo = Gtk.FileFilter
    type AttrLabel FileChooserRequestFilterPropertyInfo = "FileChooserRequest::filter"
    attrGet _ = getFileChooserRequestFilter
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "mime-types"
   -- Type: TCArray True (-1) (-1) (TBasicType TUTF8)
   -- Flags: [PropertyReadable]

getFileChooserRequestMimeTypes :: (MonadIO m, FileChooserRequestK o) => o -> m [T.Text]
getFileChooserRequestMimeTypes obj = liftIO $ getObjectPropertyStringArray obj "mime-types"

data FileChooserRequestMimeTypesPropertyInfo
instance AttrInfo FileChooserRequestMimeTypesPropertyInfo where
    type AttrAllowedOps FileChooserRequestMimeTypesPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint FileChooserRequestMimeTypesPropertyInfo = (~) ()
    type AttrBaseTypeConstraint FileChooserRequestMimeTypesPropertyInfo = FileChooserRequestK
    type AttrGetType FileChooserRequestMimeTypesPropertyInfo = [T.Text]
    type AttrLabel FileChooserRequestMimeTypesPropertyInfo = "FileChooserRequest::mime-types"
    attrGet _ = getFileChooserRequestMimeTypes
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "select-multiple"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getFileChooserRequestSelectMultiple :: (MonadIO m, FileChooserRequestK o) => o -> m Bool
getFileChooserRequestSelectMultiple obj = liftIO $ getObjectPropertyBool obj "select-multiple"

data FileChooserRequestSelectMultiplePropertyInfo
instance AttrInfo FileChooserRequestSelectMultiplePropertyInfo where
    type AttrAllowedOps FileChooserRequestSelectMultiplePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint FileChooserRequestSelectMultiplePropertyInfo = (~) ()
    type AttrBaseTypeConstraint FileChooserRequestSelectMultiplePropertyInfo = FileChooserRequestK
    type AttrGetType FileChooserRequestSelectMultiplePropertyInfo = Bool
    type AttrLabel FileChooserRequestSelectMultiplePropertyInfo = "FileChooserRequest::select-multiple"
    attrGet _ = getFileChooserRequestSelectMultiple
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "selected-files"
   -- Type: TCArray True (-1) (-1) (TBasicType TUTF8)
   -- Flags: [PropertyReadable]

getFileChooserRequestSelectedFiles :: (MonadIO m, FileChooserRequestK o) => o -> m [T.Text]
getFileChooserRequestSelectedFiles obj = liftIO $ getObjectPropertyStringArray obj "selected-files"

data FileChooserRequestSelectedFilesPropertyInfo
instance AttrInfo FileChooserRequestSelectedFilesPropertyInfo where
    type AttrAllowedOps FileChooserRequestSelectedFilesPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint FileChooserRequestSelectedFilesPropertyInfo = (~) ()
    type AttrBaseTypeConstraint FileChooserRequestSelectedFilesPropertyInfo = FileChooserRequestK
    type AttrGetType FileChooserRequestSelectedFilesPropertyInfo = [T.Text]
    type AttrLabel FileChooserRequestSelectedFilesPropertyInfo = "FileChooserRequest::selected-files"
    attrGet _ = getFileChooserRequestSelectedFiles
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList FileChooserRequest = '[ '("filter", FileChooserRequestFilterPropertyInfo), '("mime-types", FileChooserRequestMimeTypesPropertyInfo), '("select-multiple", FileChooserRequestSelectMultiplePropertyInfo), '("selected-files", FileChooserRequestSelectedFilesPropertyInfo)]

-- VVV Prop "max-match-count"
   -- Type: TBasicType TUInt32
   -- Flags: [PropertyReadable]

getFindControllerMaxMatchCount :: (MonadIO m, FindControllerK o) => o -> m Word32
getFindControllerMaxMatchCount obj = liftIO $ getObjectPropertyCUInt obj "max-match-count"

data FindControllerMaxMatchCountPropertyInfo
instance AttrInfo FindControllerMaxMatchCountPropertyInfo where
    type AttrAllowedOps FindControllerMaxMatchCountPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint FindControllerMaxMatchCountPropertyInfo = (~) ()
    type AttrBaseTypeConstraint FindControllerMaxMatchCountPropertyInfo = FindControllerK
    type AttrGetType FindControllerMaxMatchCountPropertyInfo = Word32
    type AttrLabel FindControllerMaxMatchCountPropertyInfo = "FindController::max-match-count"
    attrGet _ = getFindControllerMaxMatchCount
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "options"
   -- Type: TInterface "WebKit2" "FindOptions"
   -- Flags: [PropertyReadable]

getFindControllerOptions :: (MonadIO m, FindControllerK o) => o -> m [FindOptions]
getFindControllerOptions obj = liftIO $ getObjectPropertyFlags obj "options"

data FindControllerOptionsPropertyInfo
instance AttrInfo FindControllerOptionsPropertyInfo where
    type AttrAllowedOps FindControllerOptionsPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint FindControllerOptionsPropertyInfo = (~) ()
    type AttrBaseTypeConstraint FindControllerOptionsPropertyInfo = FindControllerK
    type AttrGetType FindControllerOptionsPropertyInfo = [FindOptions]
    type AttrLabel FindControllerOptionsPropertyInfo = "FindController::options"
    attrGet _ = getFindControllerOptions
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "text"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getFindControllerText :: (MonadIO m, FindControllerK o) => o -> m T.Text
getFindControllerText obj = liftIO $ getObjectPropertyString obj "text"

data FindControllerTextPropertyInfo
instance AttrInfo FindControllerTextPropertyInfo where
    type AttrAllowedOps FindControllerTextPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint FindControllerTextPropertyInfo = (~) ()
    type AttrBaseTypeConstraint FindControllerTextPropertyInfo = FindControllerK
    type AttrGetType FindControllerTextPropertyInfo = T.Text
    type AttrLabel FindControllerTextPropertyInfo = "FindController::text"
    attrGet _ = getFindControllerText
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "web-view"
   -- Type: TInterface "WebKit2" "WebView"
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getFindControllerWebView :: (MonadIO m, FindControllerK o) => o -> m WebView
getFindControllerWebView obj = liftIO $ getObjectPropertyObject obj "web-view" WebView

constructFindControllerWebView :: (WebViewK a) => a -> IO ([Char], GValue)
constructFindControllerWebView val = constructObjectPropertyObject "web-view" val

data FindControllerWebViewPropertyInfo
instance AttrInfo FindControllerWebViewPropertyInfo where
    type AttrAllowedOps FindControllerWebViewPropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint FindControllerWebViewPropertyInfo = WebViewK
    type AttrBaseTypeConstraint FindControllerWebViewPropertyInfo = FindControllerK
    type AttrGetType FindControllerWebViewPropertyInfo = WebView
    type AttrLabel FindControllerWebViewPropertyInfo = "FindController::web-view"
    attrGet _ = getFindControllerWebView
    attrSet _ = undefined
    attrConstruct _ = constructFindControllerWebView

type instance AttributeList FindController = '[ '("max-match-count", FindControllerMaxMatchCountPropertyInfo), '("options", FindControllerOptionsPropertyInfo), '("text", FindControllerTextPropertyInfo), '("web-view", FindControllerWebViewPropertyInfo)]

type instance AttributeList FormSubmissionRequest = '[ ]

type instance AttributeList GeolocationPermissionRequest = '[ ]

-- VVV Prop "context"
   -- Type: TBasicType TUInt32
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getHitTestResultContext :: (MonadIO m, HitTestResultK o) => o -> m Word32
getHitTestResultContext obj = liftIO $ getObjectPropertyCUInt obj "context"

constructHitTestResultContext :: Word32 -> IO ([Char], GValue)
constructHitTestResultContext val = constructObjectPropertyCUInt "context" val

data HitTestResultContextPropertyInfo
instance AttrInfo HitTestResultContextPropertyInfo where
    type AttrAllowedOps HitTestResultContextPropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint HitTestResultContextPropertyInfo = (~) Word32
    type AttrBaseTypeConstraint HitTestResultContextPropertyInfo = HitTestResultK
    type AttrGetType HitTestResultContextPropertyInfo = Word32
    type AttrLabel HitTestResultContextPropertyInfo = "HitTestResult::context"
    attrGet _ = getHitTestResultContext
    attrSet _ = undefined
    attrConstruct _ = constructHitTestResultContext

-- VVV Prop "image-uri"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getHitTestResultImageUri :: (MonadIO m, HitTestResultK o) => o -> m T.Text
getHitTestResultImageUri obj = liftIO $ getObjectPropertyString obj "image-uri"

constructHitTestResultImageUri :: T.Text -> IO ([Char], GValue)
constructHitTestResultImageUri val = constructObjectPropertyString "image-uri" val

data HitTestResultImageUriPropertyInfo
instance AttrInfo HitTestResultImageUriPropertyInfo where
    type AttrAllowedOps HitTestResultImageUriPropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint HitTestResultImageUriPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint HitTestResultImageUriPropertyInfo = HitTestResultK
    type AttrGetType HitTestResultImageUriPropertyInfo = T.Text
    type AttrLabel HitTestResultImageUriPropertyInfo = "HitTestResult::image-uri"
    attrGet _ = getHitTestResultImageUri
    attrSet _ = undefined
    attrConstruct _ = constructHitTestResultImageUri

-- VVV Prop "link-label"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getHitTestResultLinkLabel :: (MonadIO m, HitTestResultK o) => o -> m T.Text
getHitTestResultLinkLabel obj = liftIO $ getObjectPropertyString obj "link-label"

constructHitTestResultLinkLabel :: T.Text -> IO ([Char], GValue)
constructHitTestResultLinkLabel val = constructObjectPropertyString "link-label" val

data HitTestResultLinkLabelPropertyInfo
instance AttrInfo HitTestResultLinkLabelPropertyInfo where
    type AttrAllowedOps HitTestResultLinkLabelPropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint HitTestResultLinkLabelPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint HitTestResultLinkLabelPropertyInfo = HitTestResultK
    type AttrGetType HitTestResultLinkLabelPropertyInfo = T.Text
    type AttrLabel HitTestResultLinkLabelPropertyInfo = "HitTestResult::link-label"
    attrGet _ = getHitTestResultLinkLabel
    attrSet _ = undefined
    attrConstruct _ = constructHitTestResultLinkLabel

-- VVV Prop "link-title"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getHitTestResultLinkTitle :: (MonadIO m, HitTestResultK o) => o -> m T.Text
getHitTestResultLinkTitle obj = liftIO $ getObjectPropertyString obj "link-title"

constructHitTestResultLinkTitle :: T.Text -> IO ([Char], GValue)
constructHitTestResultLinkTitle val = constructObjectPropertyString "link-title" val

data HitTestResultLinkTitlePropertyInfo
instance AttrInfo HitTestResultLinkTitlePropertyInfo where
    type AttrAllowedOps HitTestResultLinkTitlePropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint HitTestResultLinkTitlePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint HitTestResultLinkTitlePropertyInfo = HitTestResultK
    type AttrGetType HitTestResultLinkTitlePropertyInfo = T.Text
    type AttrLabel HitTestResultLinkTitlePropertyInfo = "HitTestResult::link-title"
    attrGet _ = getHitTestResultLinkTitle
    attrSet _ = undefined
    attrConstruct _ = constructHitTestResultLinkTitle

-- VVV Prop "link-uri"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getHitTestResultLinkUri :: (MonadIO m, HitTestResultK o) => o -> m T.Text
getHitTestResultLinkUri obj = liftIO $ getObjectPropertyString obj "link-uri"

constructHitTestResultLinkUri :: T.Text -> IO ([Char], GValue)
constructHitTestResultLinkUri val = constructObjectPropertyString "link-uri" val

data HitTestResultLinkUriPropertyInfo
instance AttrInfo HitTestResultLinkUriPropertyInfo where
    type AttrAllowedOps HitTestResultLinkUriPropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint HitTestResultLinkUriPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint HitTestResultLinkUriPropertyInfo = HitTestResultK
    type AttrGetType HitTestResultLinkUriPropertyInfo = T.Text
    type AttrLabel HitTestResultLinkUriPropertyInfo = "HitTestResult::link-uri"
    attrGet _ = getHitTestResultLinkUri
    attrSet _ = undefined
    attrConstruct _ = constructHitTestResultLinkUri

-- VVV Prop "media-uri"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getHitTestResultMediaUri :: (MonadIO m, HitTestResultK o) => o -> m T.Text
getHitTestResultMediaUri obj = liftIO $ getObjectPropertyString obj "media-uri"

constructHitTestResultMediaUri :: T.Text -> IO ([Char], GValue)
constructHitTestResultMediaUri val = constructObjectPropertyString "media-uri" val

data HitTestResultMediaUriPropertyInfo
instance AttrInfo HitTestResultMediaUriPropertyInfo where
    type AttrAllowedOps HitTestResultMediaUriPropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint HitTestResultMediaUriPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint HitTestResultMediaUriPropertyInfo = HitTestResultK
    type AttrGetType HitTestResultMediaUriPropertyInfo = T.Text
    type AttrLabel HitTestResultMediaUriPropertyInfo = "HitTestResult::media-uri"
    attrGet _ = getHitTestResultMediaUri
    attrSet _ = undefined
    attrConstruct _ = constructHitTestResultMediaUri

type instance AttributeList HitTestResult = '[ '("context", HitTestResultContextPropertyInfo), '("image-uri", HitTestResultImageUriPropertyInfo), '("link-label", HitTestResultLinkLabelPropertyInfo), '("link-title", HitTestResultLinkTitlePropertyInfo), '("link-uri", HitTestResultLinkUriPropertyInfo), '("media-uri", HitTestResultMediaUriPropertyInfo)]

type instance AttributeList InstallMissingMediaPluginsPermissionRequest = '[ ]

-- VVV Prop "frame-name"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getNavigationPolicyDecisionFrameName :: (MonadIO m, NavigationPolicyDecisionK o) => o -> m T.Text
getNavigationPolicyDecisionFrameName obj = liftIO $ getObjectPropertyString obj "frame-name"

data NavigationPolicyDecisionFrameNamePropertyInfo
instance AttrInfo NavigationPolicyDecisionFrameNamePropertyInfo where
    type AttrAllowedOps NavigationPolicyDecisionFrameNamePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint NavigationPolicyDecisionFrameNamePropertyInfo = (~) ()
    type AttrBaseTypeConstraint NavigationPolicyDecisionFrameNamePropertyInfo = NavigationPolicyDecisionK
    type AttrGetType NavigationPolicyDecisionFrameNamePropertyInfo = T.Text
    type AttrLabel NavigationPolicyDecisionFrameNamePropertyInfo = "NavigationPolicyDecision::frame-name"
    attrGet _ = getNavigationPolicyDecisionFrameName
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "modifiers"
   -- Type: TBasicType TUInt32
   -- Flags: [PropertyReadable]

getNavigationPolicyDecisionModifiers :: (MonadIO m, NavigationPolicyDecisionK o) => o -> m Word32
getNavigationPolicyDecisionModifiers obj = liftIO $ getObjectPropertyCUInt obj "modifiers"

data NavigationPolicyDecisionModifiersPropertyInfo
instance AttrInfo NavigationPolicyDecisionModifiersPropertyInfo where
    type AttrAllowedOps NavigationPolicyDecisionModifiersPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint NavigationPolicyDecisionModifiersPropertyInfo = (~) ()
    type AttrBaseTypeConstraint NavigationPolicyDecisionModifiersPropertyInfo = NavigationPolicyDecisionK
    type AttrGetType NavigationPolicyDecisionModifiersPropertyInfo = Word32
    type AttrLabel NavigationPolicyDecisionModifiersPropertyInfo = "NavigationPolicyDecision::modifiers"
    attrGet _ = getNavigationPolicyDecisionModifiers
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "mouse-button"
   -- Type: TBasicType TUInt32
   -- Flags: [PropertyReadable]

getNavigationPolicyDecisionMouseButton :: (MonadIO m, NavigationPolicyDecisionK o) => o -> m Word32
getNavigationPolicyDecisionMouseButton obj = liftIO $ getObjectPropertyCUInt obj "mouse-button"

data NavigationPolicyDecisionMouseButtonPropertyInfo
instance AttrInfo NavigationPolicyDecisionMouseButtonPropertyInfo where
    type AttrAllowedOps NavigationPolicyDecisionMouseButtonPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint NavigationPolicyDecisionMouseButtonPropertyInfo = (~) ()
    type AttrBaseTypeConstraint NavigationPolicyDecisionMouseButtonPropertyInfo = NavigationPolicyDecisionK
    type AttrGetType NavigationPolicyDecisionMouseButtonPropertyInfo = Word32
    type AttrLabel NavigationPolicyDecisionMouseButtonPropertyInfo = "NavigationPolicyDecision::mouse-button"
    attrGet _ = getNavigationPolicyDecisionMouseButton
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "navigation-action"
   -- Type: TInterface "WebKit2" "NavigationAction"
   -- Flags: [PropertyReadable]

getNavigationPolicyDecisionNavigationAction :: (MonadIO m, NavigationPolicyDecisionK o) => o -> m NavigationAction
getNavigationPolicyDecisionNavigationAction obj = liftIO $ getObjectPropertyBoxed obj "navigation-action" NavigationAction

data NavigationPolicyDecisionNavigationActionPropertyInfo
instance AttrInfo NavigationPolicyDecisionNavigationActionPropertyInfo where
    type AttrAllowedOps NavigationPolicyDecisionNavigationActionPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint NavigationPolicyDecisionNavigationActionPropertyInfo = (~) ()
    type AttrBaseTypeConstraint NavigationPolicyDecisionNavigationActionPropertyInfo = NavigationPolicyDecisionK
    type AttrGetType NavigationPolicyDecisionNavigationActionPropertyInfo = NavigationAction
    type AttrLabel NavigationPolicyDecisionNavigationActionPropertyInfo = "NavigationPolicyDecision::navigation-action"
    attrGet _ = getNavigationPolicyDecisionNavigationAction
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "navigation-type"
   -- Type: TInterface "WebKit2" "NavigationType"
   -- Flags: [PropertyReadable]

getNavigationPolicyDecisionNavigationType :: (MonadIO m, NavigationPolicyDecisionK o) => o -> m NavigationType
getNavigationPolicyDecisionNavigationType obj = liftIO $ getObjectPropertyEnum obj "navigation-type"

data NavigationPolicyDecisionNavigationTypePropertyInfo
instance AttrInfo NavigationPolicyDecisionNavigationTypePropertyInfo where
    type AttrAllowedOps NavigationPolicyDecisionNavigationTypePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint NavigationPolicyDecisionNavigationTypePropertyInfo = (~) ()
    type AttrBaseTypeConstraint NavigationPolicyDecisionNavigationTypePropertyInfo = NavigationPolicyDecisionK
    type AttrGetType NavigationPolicyDecisionNavigationTypePropertyInfo = NavigationType
    type AttrLabel NavigationPolicyDecisionNavigationTypePropertyInfo = "NavigationPolicyDecision::navigation-type"
    attrGet _ = getNavigationPolicyDecisionNavigationType
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "request"
   -- Type: TInterface "WebKit2" "URIRequest"
   -- Flags: [PropertyReadable]

getNavigationPolicyDecisionRequest :: (MonadIO m, NavigationPolicyDecisionK o) => o -> m URIRequest
getNavigationPolicyDecisionRequest obj = liftIO $ getObjectPropertyObject obj "request" URIRequest

data NavigationPolicyDecisionRequestPropertyInfo
instance AttrInfo NavigationPolicyDecisionRequestPropertyInfo where
    type AttrAllowedOps NavigationPolicyDecisionRequestPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint NavigationPolicyDecisionRequestPropertyInfo = (~) ()
    type AttrBaseTypeConstraint NavigationPolicyDecisionRequestPropertyInfo = NavigationPolicyDecisionK
    type AttrGetType NavigationPolicyDecisionRequestPropertyInfo = URIRequest
    type AttrLabel NavigationPolicyDecisionRequestPropertyInfo = "NavigationPolicyDecision::request"
    attrGet _ = getNavigationPolicyDecisionRequest
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList NavigationPolicyDecision = '[ '("frame-name", NavigationPolicyDecisionFrameNamePropertyInfo), '("modifiers", NavigationPolicyDecisionModifiersPropertyInfo), '("mouse-button", NavigationPolicyDecisionMouseButtonPropertyInfo), '("navigation-action", NavigationPolicyDecisionNavigationActionPropertyInfo), '("navigation-type", NavigationPolicyDecisionNavigationTypePropertyInfo), '("request", NavigationPolicyDecisionRequestPropertyInfo)]

-- VVV Prop "body"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getNotificationBody :: (MonadIO m, NotificationK o) => o -> m T.Text
getNotificationBody obj = liftIO $ getObjectPropertyString obj "body"

data NotificationBodyPropertyInfo
instance AttrInfo NotificationBodyPropertyInfo where
    type AttrAllowedOps NotificationBodyPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint NotificationBodyPropertyInfo = (~) ()
    type AttrBaseTypeConstraint NotificationBodyPropertyInfo = NotificationK
    type AttrGetType NotificationBodyPropertyInfo = T.Text
    type AttrLabel NotificationBodyPropertyInfo = "Notification::body"
    attrGet _ = getNotificationBody
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "id"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getNotificationId :: (MonadIO m, NotificationK o) => o -> m Word64
getNotificationId obj = liftIO $ getObjectPropertyUInt64 obj "id"

data NotificationIdPropertyInfo
instance AttrInfo NotificationIdPropertyInfo where
    type AttrAllowedOps NotificationIdPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint NotificationIdPropertyInfo = (~) ()
    type AttrBaseTypeConstraint NotificationIdPropertyInfo = NotificationK
    type AttrGetType NotificationIdPropertyInfo = Word64
    type AttrLabel NotificationIdPropertyInfo = "Notification::id"
    attrGet _ = getNotificationId
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "title"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getNotificationTitle :: (MonadIO m, NotificationK o) => o -> m T.Text
getNotificationTitle obj = liftIO $ getObjectPropertyString obj "title"

data NotificationTitlePropertyInfo
instance AttrInfo NotificationTitlePropertyInfo where
    type AttrAllowedOps NotificationTitlePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint NotificationTitlePropertyInfo = (~) ()
    type AttrBaseTypeConstraint NotificationTitlePropertyInfo = NotificationK
    type AttrGetType NotificationTitlePropertyInfo = T.Text
    type AttrLabel NotificationTitlePropertyInfo = "Notification::title"
    attrGet _ = getNotificationTitle
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList Notification = '[ '("body", NotificationBodyPropertyInfo), '("id", NotificationIdPropertyInfo), '("title", NotificationTitlePropertyInfo)]

type instance AttributeList NotificationPermissionRequest = '[ ]

type instance AttributeList PermissionRequest = '[ ]

type instance AttributeList Plugin = '[ ]

type instance AttributeList PolicyDecision = '[ ]

-- VVV Prop "page-setup"
   -- Type: TInterface "Gtk" "PageSetup"
   -- Flags: [PropertyReadable,PropertyWritable]

getPrintOperationPageSetup :: (MonadIO m, PrintOperationK o) => o -> m Gtk.PageSetup
getPrintOperationPageSetup obj = liftIO $ getObjectPropertyObject obj "page-setup" Gtk.PageSetup

setPrintOperationPageSetup :: (MonadIO m, PrintOperationK o, Gtk.PageSetupK a) => o -> a -> m ()
setPrintOperationPageSetup obj val = liftIO $ setObjectPropertyObject obj "page-setup" val

constructPrintOperationPageSetup :: (Gtk.PageSetupK a) => a -> IO ([Char], GValue)
constructPrintOperationPageSetup val = constructObjectPropertyObject "page-setup" val

data PrintOperationPageSetupPropertyInfo
instance AttrInfo PrintOperationPageSetupPropertyInfo where
    type AttrAllowedOps PrintOperationPageSetupPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint PrintOperationPageSetupPropertyInfo = Gtk.PageSetupK
    type AttrBaseTypeConstraint PrintOperationPageSetupPropertyInfo = PrintOperationK
    type AttrGetType PrintOperationPageSetupPropertyInfo = Gtk.PageSetup
    type AttrLabel PrintOperationPageSetupPropertyInfo = "PrintOperation::page-setup"
    attrGet _ = getPrintOperationPageSetup
    attrSet _ = setPrintOperationPageSetup
    attrConstruct _ = constructPrintOperationPageSetup

-- VVV Prop "print-settings"
   -- Type: TInterface "Gtk" "PrintSettings"
   -- Flags: [PropertyReadable,PropertyWritable]

getPrintOperationPrintSettings :: (MonadIO m, PrintOperationK o) => o -> m Gtk.PrintSettings
getPrintOperationPrintSettings obj = liftIO $ getObjectPropertyObject obj "print-settings" Gtk.PrintSettings

setPrintOperationPrintSettings :: (MonadIO m, PrintOperationK o, Gtk.PrintSettingsK a) => o -> a -> m ()
setPrintOperationPrintSettings obj val = liftIO $ setObjectPropertyObject obj "print-settings" val

constructPrintOperationPrintSettings :: (Gtk.PrintSettingsK a) => a -> IO ([Char], GValue)
constructPrintOperationPrintSettings val = constructObjectPropertyObject "print-settings" val

data PrintOperationPrintSettingsPropertyInfo
instance AttrInfo PrintOperationPrintSettingsPropertyInfo where
    type AttrAllowedOps PrintOperationPrintSettingsPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint PrintOperationPrintSettingsPropertyInfo = Gtk.PrintSettingsK
    type AttrBaseTypeConstraint PrintOperationPrintSettingsPropertyInfo = PrintOperationK
    type AttrGetType PrintOperationPrintSettingsPropertyInfo = Gtk.PrintSettings
    type AttrLabel PrintOperationPrintSettingsPropertyInfo = "PrintOperation::print-settings"
    attrGet _ = getPrintOperationPrintSettings
    attrSet _ = setPrintOperationPrintSettings
    attrConstruct _ = constructPrintOperationPrintSettings

-- VVV Prop "web-view"
   -- Type: TInterface "WebKit2" "WebView"
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getPrintOperationWebView :: (MonadIO m, PrintOperationK o) => o -> m WebView
getPrintOperationWebView obj = liftIO $ getObjectPropertyObject obj "web-view" WebView

constructPrintOperationWebView :: (WebViewK a) => a -> IO ([Char], GValue)
constructPrintOperationWebView val = constructObjectPropertyObject "web-view" val

data PrintOperationWebViewPropertyInfo
instance AttrInfo PrintOperationWebViewPropertyInfo where
    type AttrAllowedOps PrintOperationWebViewPropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint PrintOperationWebViewPropertyInfo = WebViewK
    type AttrBaseTypeConstraint PrintOperationWebViewPropertyInfo = PrintOperationK
    type AttrGetType PrintOperationWebViewPropertyInfo = WebView
    type AttrLabel PrintOperationWebViewPropertyInfo = "PrintOperation::web-view"
    attrGet _ = getPrintOperationWebView
    attrSet _ = undefined
    attrConstruct _ = constructPrintOperationWebView

type instance AttributeList PrintOperation = '[ '("page-setup", PrintOperationPageSetupPropertyInfo), '("print-settings", PrintOperationPrintSettingsPropertyInfo), '("web-view", PrintOperationWebViewPropertyInfo)]

-- VVV Prop "request"
   -- Type: TInterface "WebKit2" "URIRequest"
   -- Flags: [PropertyReadable]

getResponsePolicyDecisionRequest :: (MonadIO m, ResponsePolicyDecisionK o) => o -> m URIRequest
getResponsePolicyDecisionRequest obj = liftIO $ getObjectPropertyObject obj "request" URIRequest

data ResponsePolicyDecisionRequestPropertyInfo
instance AttrInfo ResponsePolicyDecisionRequestPropertyInfo where
    type AttrAllowedOps ResponsePolicyDecisionRequestPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint ResponsePolicyDecisionRequestPropertyInfo = (~) ()
    type AttrBaseTypeConstraint ResponsePolicyDecisionRequestPropertyInfo = ResponsePolicyDecisionK
    type AttrGetType ResponsePolicyDecisionRequestPropertyInfo = URIRequest
    type AttrLabel ResponsePolicyDecisionRequestPropertyInfo = "ResponsePolicyDecision::request"
    attrGet _ = getResponsePolicyDecisionRequest
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "response"
   -- Type: TInterface "WebKit2" "URIResponse"
   -- Flags: [PropertyReadable]

getResponsePolicyDecisionResponse :: (MonadIO m, ResponsePolicyDecisionK o) => o -> m URIResponse
getResponsePolicyDecisionResponse obj = liftIO $ getObjectPropertyObject obj "response" URIResponse

data ResponsePolicyDecisionResponsePropertyInfo
instance AttrInfo ResponsePolicyDecisionResponsePropertyInfo where
    type AttrAllowedOps ResponsePolicyDecisionResponsePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint ResponsePolicyDecisionResponsePropertyInfo = (~) ()
    type AttrBaseTypeConstraint ResponsePolicyDecisionResponsePropertyInfo = ResponsePolicyDecisionK
    type AttrGetType ResponsePolicyDecisionResponsePropertyInfo = URIResponse
    type AttrLabel ResponsePolicyDecisionResponsePropertyInfo = "ResponsePolicyDecision::response"
    attrGet _ = getResponsePolicyDecisionResponse
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList ResponsePolicyDecision = '[ '("request", ResponsePolicyDecisionRequestPropertyInfo), '("response", ResponsePolicyDecisionResponsePropertyInfo)]

type instance AttributeList SecurityManager = '[ ]

-- VVV Prop "allow-file-access-from-file-urls"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsAllowFileAccessFromFileUrls :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsAllowFileAccessFromFileUrls obj = liftIO $ getObjectPropertyBool obj "allow-file-access-from-file-urls"

setSettingsAllowFileAccessFromFileUrls :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsAllowFileAccessFromFileUrls obj val = liftIO $ setObjectPropertyBool obj "allow-file-access-from-file-urls" val

constructSettingsAllowFileAccessFromFileUrls :: Bool -> IO ([Char], GValue)
constructSettingsAllowFileAccessFromFileUrls val = constructObjectPropertyBool "allow-file-access-from-file-urls" val

data SettingsAllowFileAccessFromFileUrlsPropertyInfo
instance AttrInfo SettingsAllowFileAccessFromFileUrlsPropertyInfo where
    type AttrAllowedOps SettingsAllowFileAccessFromFileUrlsPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsAllowFileAccessFromFileUrlsPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsAllowFileAccessFromFileUrlsPropertyInfo = SettingsK
    type AttrGetType SettingsAllowFileAccessFromFileUrlsPropertyInfo = Bool
    type AttrLabel SettingsAllowFileAccessFromFileUrlsPropertyInfo = "Settings::allow-file-access-from-file-urls"
    attrGet _ = getSettingsAllowFileAccessFromFileUrls
    attrSet _ = setSettingsAllowFileAccessFromFileUrls
    attrConstruct _ = constructSettingsAllowFileAccessFromFileUrls

-- VVV Prop "allow-modal-dialogs"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsAllowModalDialogs :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsAllowModalDialogs obj = liftIO $ getObjectPropertyBool obj "allow-modal-dialogs"

setSettingsAllowModalDialogs :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsAllowModalDialogs obj val = liftIO $ setObjectPropertyBool obj "allow-modal-dialogs" val

constructSettingsAllowModalDialogs :: Bool -> IO ([Char], GValue)
constructSettingsAllowModalDialogs val = constructObjectPropertyBool "allow-modal-dialogs" val

data SettingsAllowModalDialogsPropertyInfo
instance AttrInfo SettingsAllowModalDialogsPropertyInfo where
    type AttrAllowedOps SettingsAllowModalDialogsPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsAllowModalDialogsPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsAllowModalDialogsPropertyInfo = SettingsK
    type AttrGetType SettingsAllowModalDialogsPropertyInfo = Bool
    type AttrLabel SettingsAllowModalDialogsPropertyInfo = "Settings::allow-modal-dialogs"
    attrGet _ = getSettingsAllowModalDialogs
    attrSet _ = setSettingsAllowModalDialogs
    attrConstruct _ = constructSettingsAllowModalDialogs

-- VVV Prop "auto-load-images"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsAutoLoadImages :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsAutoLoadImages obj = liftIO $ getObjectPropertyBool obj "auto-load-images"

setSettingsAutoLoadImages :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsAutoLoadImages obj val = liftIO $ setObjectPropertyBool obj "auto-load-images" val

constructSettingsAutoLoadImages :: Bool -> IO ([Char], GValue)
constructSettingsAutoLoadImages val = constructObjectPropertyBool "auto-load-images" val

data SettingsAutoLoadImagesPropertyInfo
instance AttrInfo SettingsAutoLoadImagesPropertyInfo where
    type AttrAllowedOps SettingsAutoLoadImagesPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsAutoLoadImagesPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsAutoLoadImagesPropertyInfo = SettingsK
    type AttrGetType SettingsAutoLoadImagesPropertyInfo = Bool
    type AttrLabel SettingsAutoLoadImagesPropertyInfo = "Settings::auto-load-images"
    attrGet _ = getSettingsAutoLoadImages
    attrSet _ = setSettingsAutoLoadImages
    attrConstruct _ = constructSettingsAutoLoadImages

-- VVV Prop "cursive-font-family"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsCursiveFontFamily :: (MonadIO m, SettingsK o) => o -> m T.Text
getSettingsCursiveFontFamily obj = liftIO $ getObjectPropertyString obj "cursive-font-family"

setSettingsCursiveFontFamily :: (MonadIO m, SettingsK o) => o -> T.Text -> m ()
setSettingsCursiveFontFamily obj val = liftIO $ setObjectPropertyString obj "cursive-font-family" val

constructSettingsCursiveFontFamily :: T.Text -> IO ([Char], GValue)
constructSettingsCursiveFontFamily val = constructObjectPropertyString "cursive-font-family" val

data SettingsCursiveFontFamilyPropertyInfo
instance AttrInfo SettingsCursiveFontFamilyPropertyInfo where
    type AttrAllowedOps SettingsCursiveFontFamilyPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsCursiveFontFamilyPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint SettingsCursiveFontFamilyPropertyInfo = SettingsK
    type AttrGetType SettingsCursiveFontFamilyPropertyInfo = T.Text
    type AttrLabel SettingsCursiveFontFamilyPropertyInfo = "Settings::cursive-font-family"
    attrGet _ = getSettingsCursiveFontFamily
    attrSet _ = setSettingsCursiveFontFamily
    attrConstruct _ = constructSettingsCursiveFontFamily

-- VVV Prop "default-charset"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsDefaultCharset :: (MonadIO m, SettingsK o) => o -> m T.Text
getSettingsDefaultCharset obj = liftIO $ getObjectPropertyString obj "default-charset"

setSettingsDefaultCharset :: (MonadIO m, SettingsK o) => o -> T.Text -> m ()
setSettingsDefaultCharset obj val = liftIO $ setObjectPropertyString obj "default-charset" val

constructSettingsDefaultCharset :: T.Text -> IO ([Char], GValue)
constructSettingsDefaultCharset val = constructObjectPropertyString "default-charset" val

data SettingsDefaultCharsetPropertyInfo
instance AttrInfo SettingsDefaultCharsetPropertyInfo where
    type AttrAllowedOps SettingsDefaultCharsetPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsDefaultCharsetPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint SettingsDefaultCharsetPropertyInfo = SettingsK
    type AttrGetType SettingsDefaultCharsetPropertyInfo = T.Text
    type AttrLabel SettingsDefaultCharsetPropertyInfo = "Settings::default-charset"
    attrGet _ = getSettingsDefaultCharset
    attrSet _ = setSettingsDefaultCharset
    attrConstruct _ = constructSettingsDefaultCharset

-- VVV Prop "default-font-family"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsDefaultFontFamily :: (MonadIO m, SettingsK o) => o -> m T.Text
getSettingsDefaultFontFamily obj = liftIO $ getObjectPropertyString obj "default-font-family"

setSettingsDefaultFontFamily :: (MonadIO m, SettingsK o) => o -> T.Text -> m ()
setSettingsDefaultFontFamily obj val = liftIO $ setObjectPropertyString obj "default-font-family" val

constructSettingsDefaultFontFamily :: T.Text -> IO ([Char], GValue)
constructSettingsDefaultFontFamily val = constructObjectPropertyString "default-font-family" val

data SettingsDefaultFontFamilyPropertyInfo
instance AttrInfo SettingsDefaultFontFamilyPropertyInfo where
    type AttrAllowedOps SettingsDefaultFontFamilyPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsDefaultFontFamilyPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint SettingsDefaultFontFamilyPropertyInfo = SettingsK
    type AttrGetType SettingsDefaultFontFamilyPropertyInfo = T.Text
    type AttrLabel SettingsDefaultFontFamilyPropertyInfo = "Settings::default-font-family"
    attrGet _ = getSettingsDefaultFontFamily
    attrSet _ = setSettingsDefaultFontFamily
    attrConstruct _ = constructSettingsDefaultFontFamily

-- VVV Prop "default-font-size"
   -- Type: TBasicType TUInt32
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsDefaultFontSize :: (MonadIO m, SettingsK o) => o -> m Word32
getSettingsDefaultFontSize obj = liftIO $ getObjectPropertyCUInt obj "default-font-size"

setSettingsDefaultFontSize :: (MonadIO m, SettingsK o) => o -> Word32 -> m ()
setSettingsDefaultFontSize obj val = liftIO $ setObjectPropertyCUInt obj "default-font-size" val

constructSettingsDefaultFontSize :: Word32 -> IO ([Char], GValue)
constructSettingsDefaultFontSize val = constructObjectPropertyCUInt "default-font-size" val

data SettingsDefaultFontSizePropertyInfo
instance AttrInfo SettingsDefaultFontSizePropertyInfo where
    type AttrAllowedOps SettingsDefaultFontSizePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsDefaultFontSizePropertyInfo = (~) Word32
    type AttrBaseTypeConstraint SettingsDefaultFontSizePropertyInfo = SettingsK
    type AttrGetType SettingsDefaultFontSizePropertyInfo = Word32
    type AttrLabel SettingsDefaultFontSizePropertyInfo = "Settings::default-font-size"
    attrGet _ = getSettingsDefaultFontSize
    attrSet _ = setSettingsDefaultFontSize
    attrConstruct _ = constructSettingsDefaultFontSize

-- VVV Prop "default-monospace-font-size"
   -- Type: TBasicType TUInt32
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsDefaultMonospaceFontSize :: (MonadIO m, SettingsK o) => o -> m Word32
getSettingsDefaultMonospaceFontSize obj = liftIO $ getObjectPropertyCUInt obj "default-monospace-font-size"

setSettingsDefaultMonospaceFontSize :: (MonadIO m, SettingsK o) => o -> Word32 -> m ()
setSettingsDefaultMonospaceFontSize obj val = liftIO $ setObjectPropertyCUInt obj "default-monospace-font-size" val

constructSettingsDefaultMonospaceFontSize :: Word32 -> IO ([Char], GValue)
constructSettingsDefaultMonospaceFontSize val = constructObjectPropertyCUInt "default-monospace-font-size" val

data SettingsDefaultMonospaceFontSizePropertyInfo
instance AttrInfo SettingsDefaultMonospaceFontSizePropertyInfo where
    type AttrAllowedOps SettingsDefaultMonospaceFontSizePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsDefaultMonospaceFontSizePropertyInfo = (~) Word32
    type AttrBaseTypeConstraint SettingsDefaultMonospaceFontSizePropertyInfo = SettingsK
    type AttrGetType SettingsDefaultMonospaceFontSizePropertyInfo = Word32
    type AttrLabel SettingsDefaultMonospaceFontSizePropertyInfo = "Settings::default-monospace-font-size"
    attrGet _ = getSettingsDefaultMonospaceFontSize
    attrSet _ = setSettingsDefaultMonospaceFontSize
    attrConstruct _ = constructSettingsDefaultMonospaceFontSize

-- VVV Prop "draw-compositing-indicators"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsDrawCompositingIndicators :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsDrawCompositingIndicators obj = liftIO $ getObjectPropertyBool obj "draw-compositing-indicators"

setSettingsDrawCompositingIndicators :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsDrawCompositingIndicators obj val = liftIO $ setObjectPropertyBool obj "draw-compositing-indicators" val

constructSettingsDrawCompositingIndicators :: Bool -> IO ([Char], GValue)
constructSettingsDrawCompositingIndicators val = constructObjectPropertyBool "draw-compositing-indicators" val

data SettingsDrawCompositingIndicatorsPropertyInfo
instance AttrInfo SettingsDrawCompositingIndicatorsPropertyInfo where
    type AttrAllowedOps SettingsDrawCompositingIndicatorsPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsDrawCompositingIndicatorsPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsDrawCompositingIndicatorsPropertyInfo = SettingsK
    type AttrGetType SettingsDrawCompositingIndicatorsPropertyInfo = Bool
    type AttrLabel SettingsDrawCompositingIndicatorsPropertyInfo = "Settings::draw-compositing-indicators"
    attrGet _ = getSettingsDrawCompositingIndicators
    attrSet _ = setSettingsDrawCompositingIndicators
    attrConstruct _ = constructSettingsDrawCompositingIndicators

-- VVV Prop "enable-accelerated-2d-canvas"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnableAccelerated2dCanvas :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnableAccelerated2dCanvas obj = liftIO $ getObjectPropertyBool obj "enable-accelerated-2d-canvas"

setSettingsEnableAccelerated2dCanvas :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnableAccelerated2dCanvas obj val = liftIO $ setObjectPropertyBool obj "enable-accelerated-2d-canvas" val

constructSettingsEnableAccelerated2dCanvas :: Bool -> IO ([Char], GValue)
constructSettingsEnableAccelerated2dCanvas val = constructObjectPropertyBool "enable-accelerated-2d-canvas" val

data SettingsEnableAccelerated2dCanvasPropertyInfo
instance AttrInfo SettingsEnableAccelerated2dCanvasPropertyInfo where
    type AttrAllowedOps SettingsEnableAccelerated2dCanvasPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableAccelerated2dCanvasPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableAccelerated2dCanvasPropertyInfo = SettingsK
    type AttrGetType SettingsEnableAccelerated2dCanvasPropertyInfo = Bool
    type AttrLabel SettingsEnableAccelerated2dCanvasPropertyInfo = "Settings::enable-accelerated-2d-canvas"
    attrGet _ = getSettingsEnableAccelerated2dCanvas
    attrSet _ = setSettingsEnableAccelerated2dCanvas
    attrConstruct _ = constructSettingsEnableAccelerated2dCanvas

-- VVV Prop "enable-caret-browsing"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnableCaretBrowsing :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnableCaretBrowsing obj = liftIO $ getObjectPropertyBool obj "enable-caret-browsing"

setSettingsEnableCaretBrowsing :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnableCaretBrowsing obj val = liftIO $ setObjectPropertyBool obj "enable-caret-browsing" val

constructSettingsEnableCaretBrowsing :: Bool -> IO ([Char], GValue)
constructSettingsEnableCaretBrowsing val = constructObjectPropertyBool "enable-caret-browsing" val

data SettingsEnableCaretBrowsingPropertyInfo
instance AttrInfo SettingsEnableCaretBrowsingPropertyInfo where
    type AttrAllowedOps SettingsEnableCaretBrowsingPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableCaretBrowsingPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableCaretBrowsingPropertyInfo = SettingsK
    type AttrGetType SettingsEnableCaretBrowsingPropertyInfo = Bool
    type AttrLabel SettingsEnableCaretBrowsingPropertyInfo = "Settings::enable-caret-browsing"
    attrGet _ = getSettingsEnableCaretBrowsing
    attrSet _ = setSettingsEnableCaretBrowsing
    attrConstruct _ = constructSettingsEnableCaretBrowsing

-- VVV Prop "enable-developer-extras"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnableDeveloperExtras :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnableDeveloperExtras obj = liftIO $ getObjectPropertyBool obj "enable-developer-extras"

setSettingsEnableDeveloperExtras :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnableDeveloperExtras obj val = liftIO $ setObjectPropertyBool obj "enable-developer-extras" val

constructSettingsEnableDeveloperExtras :: Bool -> IO ([Char], GValue)
constructSettingsEnableDeveloperExtras val = constructObjectPropertyBool "enable-developer-extras" val

data SettingsEnableDeveloperExtrasPropertyInfo
instance AttrInfo SettingsEnableDeveloperExtrasPropertyInfo where
    type AttrAllowedOps SettingsEnableDeveloperExtrasPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableDeveloperExtrasPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableDeveloperExtrasPropertyInfo = SettingsK
    type AttrGetType SettingsEnableDeveloperExtrasPropertyInfo = Bool
    type AttrLabel SettingsEnableDeveloperExtrasPropertyInfo = "Settings::enable-developer-extras"
    attrGet _ = getSettingsEnableDeveloperExtras
    attrSet _ = setSettingsEnableDeveloperExtras
    attrConstruct _ = constructSettingsEnableDeveloperExtras

-- VVV Prop "enable-dns-prefetching"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnableDnsPrefetching :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnableDnsPrefetching obj = liftIO $ getObjectPropertyBool obj "enable-dns-prefetching"

setSettingsEnableDnsPrefetching :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnableDnsPrefetching obj val = liftIO $ setObjectPropertyBool obj "enable-dns-prefetching" val

constructSettingsEnableDnsPrefetching :: Bool -> IO ([Char], GValue)
constructSettingsEnableDnsPrefetching val = constructObjectPropertyBool "enable-dns-prefetching" val

data SettingsEnableDnsPrefetchingPropertyInfo
instance AttrInfo SettingsEnableDnsPrefetchingPropertyInfo where
    type AttrAllowedOps SettingsEnableDnsPrefetchingPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableDnsPrefetchingPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableDnsPrefetchingPropertyInfo = SettingsK
    type AttrGetType SettingsEnableDnsPrefetchingPropertyInfo = Bool
    type AttrLabel SettingsEnableDnsPrefetchingPropertyInfo = "Settings::enable-dns-prefetching"
    attrGet _ = getSettingsEnableDnsPrefetching
    attrSet _ = setSettingsEnableDnsPrefetching
    attrConstruct _ = constructSettingsEnableDnsPrefetching

-- VVV Prop "enable-frame-flattening"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnableFrameFlattening :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnableFrameFlattening obj = liftIO $ getObjectPropertyBool obj "enable-frame-flattening"

setSettingsEnableFrameFlattening :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnableFrameFlattening obj val = liftIO $ setObjectPropertyBool obj "enable-frame-flattening" val

constructSettingsEnableFrameFlattening :: Bool -> IO ([Char], GValue)
constructSettingsEnableFrameFlattening val = constructObjectPropertyBool "enable-frame-flattening" val

data SettingsEnableFrameFlatteningPropertyInfo
instance AttrInfo SettingsEnableFrameFlatteningPropertyInfo where
    type AttrAllowedOps SettingsEnableFrameFlatteningPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableFrameFlatteningPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableFrameFlatteningPropertyInfo = SettingsK
    type AttrGetType SettingsEnableFrameFlatteningPropertyInfo = Bool
    type AttrLabel SettingsEnableFrameFlatteningPropertyInfo = "Settings::enable-frame-flattening"
    attrGet _ = getSettingsEnableFrameFlattening
    attrSet _ = setSettingsEnableFrameFlattening
    attrConstruct _ = constructSettingsEnableFrameFlattening

-- VVV Prop "enable-fullscreen"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnableFullscreen :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnableFullscreen obj = liftIO $ getObjectPropertyBool obj "enable-fullscreen"

setSettingsEnableFullscreen :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnableFullscreen obj val = liftIO $ setObjectPropertyBool obj "enable-fullscreen" val

constructSettingsEnableFullscreen :: Bool -> IO ([Char], GValue)
constructSettingsEnableFullscreen val = constructObjectPropertyBool "enable-fullscreen" val

data SettingsEnableFullscreenPropertyInfo
instance AttrInfo SettingsEnableFullscreenPropertyInfo where
    type AttrAllowedOps SettingsEnableFullscreenPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableFullscreenPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableFullscreenPropertyInfo = SettingsK
    type AttrGetType SettingsEnableFullscreenPropertyInfo = Bool
    type AttrLabel SettingsEnableFullscreenPropertyInfo = "Settings::enable-fullscreen"
    attrGet _ = getSettingsEnableFullscreen
    attrSet _ = setSettingsEnableFullscreen
    attrConstruct _ = constructSettingsEnableFullscreen

-- VVV Prop "enable-html5-database"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnableHtml5Database :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnableHtml5Database obj = liftIO $ getObjectPropertyBool obj "enable-html5-database"

setSettingsEnableHtml5Database :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnableHtml5Database obj val = liftIO $ setObjectPropertyBool obj "enable-html5-database" val

constructSettingsEnableHtml5Database :: Bool -> IO ([Char], GValue)
constructSettingsEnableHtml5Database val = constructObjectPropertyBool "enable-html5-database" val

data SettingsEnableHtml5DatabasePropertyInfo
instance AttrInfo SettingsEnableHtml5DatabasePropertyInfo where
    type AttrAllowedOps SettingsEnableHtml5DatabasePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableHtml5DatabasePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableHtml5DatabasePropertyInfo = SettingsK
    type AttrGetType SettingsEnableHtml5DatabasePropertyInfo = Bool
    type AttrLabel SettingsEnableHtml5DatabasePropertyInfo = "Settings::enable-html5-database"
    attrGet _ = getSettingsEnableHtml5Database
    attrSet _ = setSettingsEnableHtml5Database
    attrConstruct _ = constructSettingsEnableHtml5Database

-- VVV Prop "enable-html5-local-storage"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnableHtml5LocalStorage :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnableHtml5LocalStorage obj = liftIO $ getObjectPropertyBool obj "enable-html5-local-storage"

setSettingsEnableHtml5LocalStorage :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnableHtml5LocalStorage obj val = liftIO $ setObjectPropertyBool obj "enable-html5-local-storage" val

constructSettingsEnableHtml5LocalStorage :: Bool -> IO ([Char], GValue)
constructSettingsEnableHtml5LocalStorage val = constructObjectPropertyBool "enable-html5-local-storage" val

data SettingsEnableHtml5LocalStoragePropertyInfo
instance AttrInfo SettingsEnableHtml5LocalStoragePropertyInfo where
    type AttrAllowedOps SettingsEnableHtml5LocalStoragePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableHtml5LocalStoragePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableHtml5LocalStoragePropertyInfo = SettingsK
    type AttrGetType SettingsEnableHtml5LocalStoragePropertyInfo = Bool
    type AttrLabel SettingsEnableHtml5LocalStoragePropertyInfo = "Settings::enable-html5-local-storage"
    attrGet _ = getSettingsEnableHtml5LocalStorage
    attrSet _ = setSettingsEnableHtml5LocalStorage
    attrConstruct _ = constructSettingsEnableHtml5LocalStorage

-- VVV Prop "enable-hyperlink-auditing"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnableHyperlinkAuditing :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnableHyperlinkAuditing obj = liftIO $ getObjectPropertyBool obj "enable-hyperlink-auditing"

setSettingsEnableHyperlinkAuditing :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnableHyperlinkAuditing obj val = liftIO $ setObjectPropertyBool obj "enable-hyperlink-auditing" val

constructSettingsEnableHyperlinkAuditing :: Bool -> IO ([Char], GValue)
constructSettingsEnableHyperlinkAuditing val = constructObjectPropertyBool "enable-hyperlink-auditing" val

data SettingsEnableHyperlinkAuditingPropertyInfo
instance AttrInfo SettingsEnableHyperlinkAuditingPropertyInfo where
    type AttrAllowedOps SettingsEnableHyperlinkAuditingPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableHyperlinkAuditingPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableHyperlinkAuditingPropertyInfo = SettingsK
    type AttrGetType SettingsEnableHyperlinkAuditingPropertyInfo = Bool
    type AttrLabel SettingsEnableHyperlinkAuditingPropertyInfo = "Settings::enable-hyperlink-auditing"
    attrGet _ = getSettingsEnableHyperlinkAuditing
    attrSet _ = setSettingsEnableHyperlinkAuditing
    attrConstruct _ = constructSettingsEnableHyperlinkAuditing

-- VVV Prop "enable-java"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnableJava :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnableJava obj = liftIO $ getObjectPropertyBool obj "enable-java"

setSettingsEnableJava :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnableJava obj val = liftIO $ setObjectPropertyBool obj "enable-java" val

constructSettingsEnableJava :: Bool -> IO ([Char], GValue)
constructSettingsEnableJava val = constructObjectPropertyBool "enable-java" val

data SettingsEnableJavaPropertyInfo
instance AttrInfo SettingsEnableJavaPropertyInfo where
    type AttrAllowedOps SettingsEnableJavaPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableJavaPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableJavaPropertyInfo = SettingsK
    type AttrGetType SettingsEnableJavaPropertyInfo = Bool
    type AttrLabel SettingsEnableJavaPropertyInfo = "Settings::enable-java"
    attrGet _ = getSettingsEnableJava
    attrSet _ = setSettingsEnableJava
    attrConstruct _ = constructSettingsEnableJava

-- VVV Prop "enable-javascript"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnableJavascript :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnableJavascript obj = liftIO $ getObjectPropertyBool obj "enable-javascript"

setSettingsEnableJavascript :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnableJavascript obj val = liftIO $ setObjectPropertyBool obj "enable-javascript" val

constructSettingsEnableJavascript :: Bool -> IO ([Char], GValue)
constructSettingsEnableJavascript val = constructObjectPropertyBool "enable-javascript" val

data SettingsEnableJavascriptPropertyInfo
instance AttrInfo SettingsEnableJavascriptPropertyInfo where
    type AttrAllowedOps SettingsEnableJavascriptPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableJavascriptPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableJavascriptPropertyInfo = SettingsK
    type AttrGetType SettingsEnableJavascriptPropertyInfo = Bool
    type AttrLabel SettingsEnableJavascriptPropertyInfo = "Settings::enable-javascript"
    attrGet _ = getSettingsEnableJavascript
    attrSet _ = setSettingsEnableJavascript
    attrConstruct _ = constructSettingsEnableJavascript

-- VVV Prop "enable-media-stream"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnableMediaStream :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnableMediaStream obj = liftIO $ getObjectPropertyBool obj "enable-media-stream"

setSettingsEnableMediaStream :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnableMediaStream obj val = liftIO $ setObjectPropertyBool obj "enable-media-stream" val

constructSettingsEnableMediaStream :: Bool -> IO ([Char], GValue)
constructSettingsEnableMediaStream val = constructObjectPropertyBool "enable-media-stream" val

data SettingsEnableMediaStreamPropertyInfo
instance AttrInfo SettingsEnableMediaStreamPropertyInfo where
    type AttrAllowedOps SettingsEnableMediaStreamPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableMediaStreamPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableMediaStreamPropertyInfo = SettingsK
    type AttrGetType SettingsEnableMediaStreamPropertyInfo = Bool
    type AttrLabel SettingsEnableMediaStreamPropertyInfo = "Settings::enable-media-stream"
    attrGet _ = getSettingsEnableMediaStream
    attrSet _ = setSettingsEnableMediaStream
    attrConstruct _ = constructSettingsEnableMediaStream

-- VVV Prop "enable-mediasource"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnableMediasource :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnableMediasource obj = liftIO $ getObjectPropertyBool obj "enable-mediasource"

setSettingsEnableMediasource :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnableMediasource obj val = liftIO $ setObjectPropertyBool obj "enable-mediasource" val

constructSettingsEnableMediasource :: Bool -> IO ([Char], GValue)
constructSettingsEnableMediasource val = constructObjectPropertyBool "enable-mediasource" val

data SettingsEnableMediasourcePropertyInfo
instance AttrInfo SettingsEnableMediasourcePropertyInfo where
    type AttrAllowedOps SettingsEnableMediasourcePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableMediasourcePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableMediasourcePropertyInfo = SettingsK
    type AttrGetType SettingsEnableMediasourcePropertyInfo = Bool
    type AttrLabel SettingsEnableMediasourcePropertyInfo = "Settings::enable-mediasource"
    attrGet _ = getSettingsEnableMediasource
    attrSet _ = setSettingsEnableMediasource
    attrConstruct _ = constructSettingsEnableMediasource

-- VVV Prop "enable-offline-web-application-cache"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnableOfflineWebApplicationCache :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnableOfflineWebApplicationCache obj = liftIO $ getObjectPropertyBool obj "enable-offline-web-application-cache"

setSettingsEnableOfflineWebApplicationCache :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnableOfflineWebApplicationCache obj val = liftIO $ setObjectPropertyBool obj "enable-offline-web-application-cache" val

constructSettingsEnableOfflineWebApplicationCache :: Bool -> IO ([Char], GValue)
constructSettingsEnableOfflineWebApplicationCache val = constructObjectPropertyBool "enable-offline-web-application-cache" val

data SettingsEnableOfflineWebApplicationCachePropertyInfo
instance AttrInfo SettingsEnableOfflineWebApplicationCachePropertyInfo where
    type AttrAllowedOps SettingsEnableOfflineWebApplicationCachePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableOfflineWebApplicationCachePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableOfflineWebApplicationCachePropertyInfo = SettingsK
    type AttrGetType SettingsEnableOfflineWebApplicationCachePropertyInfo = Bool
    type AttrLabel SettingsEnableOfflineWebApplicationCachePropertyInfo = "Settings::enable-offline-web-application-cache"
    attrGet _ = getSettingsEnableOfflineWebApplicationCache
    attrSet _ = setSettingsEnableOfflineWebApplicationCache
    attrConstruct _ = constructSettingsEnableOfflineWebApplicationCache

-- VVV Prop "enable-page-cache"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnablePageCache :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnablePageCache obj = liftIO $ getObjectPropertyBool obj "enable-page-cache"

setSettingsEnablePageCache :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnablePageCache obj val = liftIO $ setObjectPropertyBool obj "enable-page-cache" val

constructSettingsEnablePageCache :: Bool -> IO ([Char], GValue)
constructSettingsEnablePageCache val = constructObjectPropertyBool "enable-page-cache" val

data SettingsEnablePageCachePropertyInfo
instance AttrInfo SettingsEnablePageCachePropertyInfo where
    type AttrAllowedOps SettingsEnablePageCachePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnablePageCachePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnablePageCachePropertyInfo = SettingsK
    type AttrGetType SettingsEnablePageCachePropertyInfo = Bool
    type AttrLabel SettingsEnablePageCachePropertyInfo = "Settings::enable-page-cache"
    attrGet _ = getSettingsEnablePageCache
    attrSet _ = setSettingsEnablePageCache
    attrConstruct _ = constructSettingsEnablePageCache

-- VVV Prop "enable-plugins"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnablePlugins :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnablePlugins obj = liftIO $ getObjectPropertyBool obj "enable-plugins"

setSettingsEnablePlugins :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnablePlugins obj val = liftIO $ setObjectPropertyBool obj "enable-plugins" val

constructSettingsEnablePlugins :: Bool -> IO ([Char], GValue)
constructSettingsEnablePlugins val = constructObjectPropertyBool "enable-plugins" val

data SettingsEnablePluginsPropertyInfo
instance AttrInfo SettingsEnablePluginsPropertyInfo where
    type AttrAllowedOps SettingsEnablePluginsPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnablePluginsPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnablePluginsPropertyInfo = SettingsK
    type AttrGetType SettingsEnablePluginsPropertyInfo = Bool
    type AttrLabel SettingsEnablePluginsPropertyInfo = "Settings::enable-plugins"
    attrGet _ = getSettingsEnablePlugins
    attrSet _ = setSettingsEnablePlugins
    attrConstruct _ = constructSettingsEnablePlugins

-- VVV Prop "enable-private-browsing"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnablePrivateBrowsing :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnablePrivateBrowsing obj = liftIO $ getObjectPropertyBool obj "enable-private-browsing"

setSettingsEnablePrivateBrowsing :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnablePrivateBrowsing obj val = liftIO $ setObjectPropertyBool obj "enable-private-browsing" val

constructSettingsEnablePrivateBrowsing :: Bool -> IO ([Char], GValue)
constructSettingsEnablePrivateBrowsing val = constructObjectPropertyBool "enable-private-browsing" val

data SettingsEnablePrivateBrowsingPropertyInfo
instance AttrInfo SettingsEnablePrivateBrowsingPropertyInfo where
    type AttrAllowedOps SettingsEnablePrivateBrowsingPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnablePrivateBrowsingPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnablePrivateBrowsingPropertyInfo = SettingsK
    type AttrGetType SettingsEnablePrivateBrowsingPropertyInfo = Bool
    type AttrLabel SettingsEnablePrivateBrowsingPropertyInfo = "Settings::enable-private-browsing"
    attrGet _ = getSettingsEnablePrivateBrowsing
    attrSet _ = setSettingsEnablePrivateBrowsing
    attrConstruct _ = constructSettingsEnablePrivateBrowsing

-- VVV Prop "enable-resizable-text-areas"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnableResizableTextAreas :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnableResizableTextAreas obj = liftIO $ getObjectPropertyBool obj "enable-resizable-text-areas"

setSettingsEnableResizableTextAreas :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnableResizableTextAreas obj val = liftIO $ setObjectPropertyBool obj "enable-resizable-text-areas" val

constructSettingsEnableResizableTextAreas :: Bool -> IO ([Char], GValue)
constructSettingsEnableResizableTextAreas val = constructObjectPropertyBool "enable-resizable-text-areas" val

data SettingsEnableResizableTextAreasPropertyInfo
instance AttrInfo SettingsEnableResizableTextAreasPropertyInfo where
    type AttrAllowedOps SettingsEnableResizableTextAreasPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableResizableTextAreasPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableResizableTextAreasPropertyInfo = SettingsK
    type AttrGetType SettingsEnableResizableTextAreasPropertyInfo = Bool
    type AttrLabel SettingsEnableResizableTextAreasPropertyInfo = "Settings::enable-resizable-text-areas"
    attrGet _ = getSettingsEnableResizableTextAreas
    attrSet _ = setSettingsEnableResizableTextAreas
    attrConstruct _ = constructSettingsEnableResizableTextAreas

-- VVV Prop "enable-site-specific-quirks"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnableSiteSpecificQuirks :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnableSiteSpecificQuirks obj = liftIO $ getObjectPropertyBool obj "enable-site-specific-quirks"

setSettingsEnableSiteSpecificQuirks :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnableSiteSpecificQuirks obj val = liftIO $ setObjectPropertyBool obj "enable-site-specific-quirks" val

constructSettingsEnableSiteSpecificQuirks :: Bool -> IO ([Char], GValue)
constructSettingsEnableSiteSpecificQuirks val = constructObjectPropertyBool "enable-site-specific-quirks" val

data SettingsEnableSiteSpecificQuirksPropertyInfo
instance AttrInfo SettingsEnableSiteSpecificQuirksPropertyInfo where
    type AttrAllowedOps SettingsEnableSiteSpecificQuirksPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableSiteSpecificQuirksPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableSiteSpecificQuirksPropertyInfo = SettingsK
    type AttrGetType SettingsEnableSiteSpecificQuirksPropertyInfo = Bool
    type AttrLabel SettingsEnableSiteSpecificQuirksPropertyInfo = "Settings::enable-site-specific-quirks"
    attrGet _ = getSettingsEnableSiteSpecificQuirks
    attrSet _ = setSettingsEnableSiteSpecificQuirks
    attrConstruct _ = constructSettingsEnableSiteSpecificQuirks

-- VVV Prop "enable-smooth-scrolling"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnableSmoothScrolling :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnableSmoothScrolling obj = liftIO $ getObjectPropertyBool obj "enable-smooth-scrolling"

setSettingsEnableSmoothScrolling :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnableSmoothScrolling obj val = liftIO $ setObjectPropertyBool obj "enable-smooth-scrolling" val

constructSettingsEnableSmoothScrolling :: Bool -> IO ([Char], GValue)
constructSettingsEnableSmoothScrolling val = constructObjectPropertyBool "enable-smooth-scrolling" val

data SettingsEnableSmoothScrollingPropertyInfo
instance AttrInfo SettingsEnableSmoothScrollingPropertyInfo where
    type AttrAllowedOps SettingsEnableSmoothScrollingPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableSmoothScrollingPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableSmoothScrollingPropertyInfo = SettingsK
    type AttrGetType SettingsEnableSmoothScrollingPropertyInfo = Bool
    type AttrLabel SettingsEnableSmoothScrollingPropertyInfo = "Settings::enable-smooth-scrolling"
    attrGet _ = getSettingsEnableSmoothScrolling
    attrSet _ = setSettingsEnableSmoothScrolling
    attrConstruct _ = constructSettingsEnableSmoothScrolling

-- VVV Prop "enable-spatial-navigation"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnableSpatialNavigation :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnableSpatialNavigation obj = liftIO $ getObjectPropertyBool obj "enable-spatial-navigation"

setSettingsEnableSpatialNavigation :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnableSpatialNavigation obj val = liftIO $ setObjectPropertyBool obj "enable-spatial-navigation" val

constructSettingsEnableSpatialNavigation :: Bool -> IO ([Char], GValue)
constructSettingsEnableSpatialNavigation val = constructObjectPropertyBool "enable-spatial-navigation" val

data SettingsEnableSpatialNavigationPropertyInfo
instance AttrInfo SettingsEnableSpatialNavigationPropertyInfo where
    type AttrAllowedOps SettingsEnableSpatialNavigationPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableSpatialNavigationPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableSpatialNavigationPropertyInfo = SettingsK
    type AttrGetType SettingsEnableSpatialNavigationPropertyInfo = Bool
    type AttrLabel SettingsEnableSpatialNavigationPropertyInfo = "Settings::enable-spatial-navigation"
    attrGet _ = getSettingsEnableSpatialNavigation
    attrSet _ = setSettingsEnableSpatialNavigation
    attrConstruct _ = constructSettingsEnableSpatialNavigation

-- VVV Prop "enable-tabs-to-links"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnableTabsToLinks :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnableTabsToLinks obj = liftIO $ getObjectPropertyBool obj "enable-tabs-to-links"

setSettingsEnableTabsToLinks :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnableTabsToLinks obj val = liftIO $ setObjectPropertyBool obj "enable-tabs-to-links" val

constructSettingsEnableTabsToLinks :: Bool -> IO ([Char], GValue)
constructSettingsEnableTabsToLinks val = constructObjectPropertyBool "enable-tabs-to-links" val

data SettingsEnableTabsToLinksPropertyInfo
instance AttrInfo SettingsEnableTabsToLinksPropertyInfo where
    type AttrAllowedOps SettingsEnableTabsToLinksPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableTabsToLinksPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableTabsToLinksPropertyInfo = SettingsK
    type AttrGetType SettingsEnableTabsToLinksPropertyInfo = Bool
    type AttrLabel SettingsEnableTabsToLinksPropertyInfo = "Settings::enable-tabs-to-links"
    attrGet _ = getSettingsEnableTabsToLinks
    attrSet _ = setSettingsEnableTabsToLinks
    attrConstruct _ = constructSettingsEnableTabsToLinks

-- VVV Prop "enable-webaudio"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnableWebaudio :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnableWebaudio obj = liftIO $ getObjectPropertyBool obj "enable-webaudio"

setSettingsEnableWebaudio :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnableWebaudio obj val = liftIO $ setObjectPropertyBool obj "enable-webaudio" val

constructSettingsEnableWebaudio :: Bool -> IO ([Char], GValue)
constructSettingsEnableWebaudio val = constructObjectPropertyBool "enable-webaudio" val

data SettingsEnableWebaudioPropertyInfo
instance AttrInfo SettingsEnableWebaudioPropertyInfo where
    type AttrAllowedOps SettingsEnableWebaudioPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableWebaudioPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableWebaudioPropertyInfo = SettingsK
    type AttrGetType SettingsEnableWebaudioPropertyInfo = Bool
    type AttrLabel SettingsEnableWebaudioPropertyInfo = "Settings::enable-webaudio"
    attrGet _ = getSettingsEnableWebaudio
    attrSet _ = setSettingsEnableWebaudio
    attrConstruct _ = constructSettingsEnableWebaudio

-- VVV Prop "enable-webgl"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnableWebgl :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnableWebgl obj = liftIO $ getObjectPropertyBool obj "enable-webgl"

setSettingsEnableWebgl :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnableWebgl obj val = liftIO $ setObjectPropertyBool obj "enable-webgl" val

constructSettingsEnableWebgl :: Bool -> IO ([Char], GValue)
constructSettingsEnableWebgl val = constructObjectPropertyBool "enable-webgl" val

data SettingsEnableWebglPropertyInfo
instance AttrInfo SettingsEnableWebglPropertyInfo where
    type AttrAllowedOps SettingsEnableWebglPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableWebglPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableWebglPropertyInfo = SettingsK
    type AttrGetType SettingsEnableWebglPropertyInfo = Bool
    type AttrLabel SettingsEnableWebglPropertyInfo = "Settings::enable-webgl"
    attrGet _ = getSettingsEnableWebgl
    attrSet _ = setSettingsEnableWebgl
    attrConstruct _ = constructSettingsEnableWebgl

-- VVV Prop "enable-write-console-messages-to-stdout"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnableWriteConsoleMessagesToStdout :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnableWriteConsoleMessagesToStdout obj = liftIO $ getObjectPropertyBool obj "enable-write-console-messages-to-stdout"

setSettingsEnableWriteConsoleMessagesToStdout :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnableWriteConsoleMessagesToStdout obj val = liftIO $ setObjectPropertyBool obj "enable-write-console-messages-to-stdout" val

constructSettingsEnableWriteConsoleMessagesToStdout :: Bool -> IO ([Char], GValue)
constructSettingsEnableWriteConsoleMessagesToStdout val = constructObjectPropertyBool "enable-write-console-messages-to-stdout" val

data SettingsEnableWriteConsoleMessagesToStdoutPropertyInfo
instance AttrInfo SettingsEnableWriteConsoleMessagesToStdoutPropertyInfo where
    type AttrAllowedOps SettingsEnableWriteConsoleMessagesToStdoutPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableWriteConsoleMessagesToStdoutPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableWriteConsoleMessagesToStdoutPropertyInfo = SettingsK
    type AttrGetType SettingsEnableWriteConsoleMessagesToStdoutPropertyInfo = Bool
    type AttrLabel SettingsEnableWriteConsoleMessagesToStdoutPropertyInfo = "Settings::enable-write-console-messages-to-stdout"
    attrGet _ = getSettingsEnableWriteConsoleMessagesToStdout
    attrSet _ = setSettingsEnableWriteConsoleMessagesToStdout
    attrConstruct _ = constructSettingsEnableWriteConsoleMessagesToStdout

-- VVV Prop "enable-xss-auditor"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsEnableXssAuditor :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsEnableXssAuditor obj = liftIO $ getObjectPropertyBool obj "enable-xss-auditor"

setSettingsEnableXssAuditor :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsEnableXssAuditor obj val = liftIO $ setObjectPropertyBool obj "enable-xss-auditor" val

constructSettingsEnableXssAuditor :: Bool -> IO ([Char], GValue)
constructSettingsEnableXssAuditor val = constructObjectPropertyBool "enable-xss-auditor" val

data SettingsEnableXssAuditorPropertyInfo
instance AttrInfo SettingsEnableXssAuditorPropertyInfo where
    type AttrAllowedOps SettingsEnableXssAuditorPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsEnableXssAuditorPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsEnableXssAuditorPropertyInfo = SettingsK
    type AttrGetType SettingsEnableXssAuditorPropertyInfo = Bool
    type AttrLabel SettingsEnableXssAuditorPropertyInfo = "Settings::enable-xss-auditor"
    attrGet _ = getSettingsEnableXssAuditor
    attrSet _ = setSettingsEnableXssAuditor
    attrConstruct _ = constructSettingsEnableXssAuditor

-- VVV Prop "fantasy-font-family"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsFantasyFontFamily :: (MonadIO m, SettingsK o) => o -> m T.Text
getSettingsFantasyFontFamily obj = liftIO $ getObjectPropertyString obj "fantasy-font-family"

setSettingsFantasyFontFamily :: (MonadIO m, SettingsK o) => o -> T.Text -> m ()
setSettingsFantasyFontFamily obj val = liftIO $ setObjectPropertyString obj "fantasy-font-family" val

constructSettingsFantasyFontFamily :: T.Text -> IO ([Char], GValue)
constructSettingsFantasyFontFamily val = constructObjectPropertyString "fantasy-font-family" val

data SettingsFantasyFontFamilyPropertyInfo
instance AttrInfo SettingsFantasyFontFamilyPropertyInfo where
    type AttrAllowedOps SettingsFantasyFontFamilyPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsFantasyFontFamilyPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint SettingsFantasyFontFamilyPropertyInfo = SettingsK
    type AttrGetType SettingsFantasyFontFamilyPropertyInfo = T.Text
    type AttrLabel SettingsFantasyFontFamilyPropertyInfo = "Settings::fantasy-font-family"
    attrGet _ = getSettingsFantasyFontFamily
    attrSet _ = setSettingsFantasyFontFamily
    attrConstruct _ = constructSettingsFantasyFontFamily

-- VVV Prop "javascript-can-access-clipboard"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsJavascriptCanAccessClipboard :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsJavascriptCanAccessClipboard obj = liftIO $ getObjectPropertyBool obj "javascript-can-access-clipboard"

setSettingsJavascriptCanAccessClipboard :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsJavascriptCanAccessClipboard obj val = liftIO $ setObjectPropertyBool obj "javascript-can-access-clipboard" val

constructSettingsJavascriptCanAccessClipboard :: Bool -> IO ([Char], GValue)
constructSettingsJavascriptCanAccessClipboard val = constructObjectPropertyBool "javascript-can-access-clipboard" val

data SettingsJavascriptCanAccessClipboardPropertyInfo
instance AttrInfo SettingsJavascriptCanAccessClipboardPropertyInfo where
    type AttrAllowedOps SettingsJavascriptCanAccessClipboardPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsJavascriptCanAccessClipboardPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsJavascriptCanAccessClipboardPropertyInfo = SettingsK
    type AttrGetType SettingsJavascriptCanAccessClipboardPropertyInfo = Bool
    type AttrLabel SettingsJavascriptCanAccessClipboardPropertyInfo = "Settings::javascript-can-access-clipboard"
    attrGet _ = getSettingsJavascriptCanAccessClipboard
    attrSet _ = setSettingsJavascriptCanAccessClipboard
    attrConstruct _ = constructSettingsJavascriptCanAccessClipboard

-- VVV Prop "javascript-can-open-windows-automatically"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsJavascriptCanOpenWindowsAutomatically :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsJavascriptCanOpenWindowsAutomatically obj = liftIO $ getObjectPropertyBool obj "javascript-can-open-windows-automatically"

setSettingsJavascriptCanOpenWindowsAutomatically :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsJavascriptCanOpenWindowsAutomatically obj val = liftIO $ setObjectPropertyBool obj "javascript-can-open-windows-automatically" val

constructSettingsJavascriptCanOpenWindowsAutomatically :: Bool -> IO ([Char], GValue)
constructSettingsJavascriptCanOpenWindowsAutomatically val = constructObjectPropertyBool "javascript-can-open-windows-automatically" val

data SettingsJavascriptCanOpenWindowsAutomaticallyPropertyInfo
instance AttrInfo SettingsJavascriptCanOpenWindowsAutomaticallyPropertyInfo where
    type AttrAllowedOps SettingsJavascriptCanOpenWindowsAutomaticallyPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsJavascriptCanOpenWindowsAutomaticallyPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsJavascriptCanOpenWindowsAutomaticallyPropertyInfo = SettingsK
    type AttrGetType SettingsJavascriptCanOpenWindowsAutomaticallyPropertyInfo = Bool
    type AttrLabel SettingsJavascriptCanOpenWindowsAutomaticallyPropertyInfo = "Settings::javascript-can-open-windows-automatically"
    attrGet _ = getSettingsJavascriptCanOpenWindowsAutomatically
    attrSet _ = setSettingsJavascriptCanOpenWindowsAutomatically
    attrConstruct _ = constructSettingsJavascriptCanOpenWindowsAutomatically

-- VVV Prop "load-icons-ignoring-image-load-setting"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsLoadIconsIgnoringImageLoadSetting :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsLoadIconsIgnoringImageLoadSetting obj = liftIO $ getObjectPropertyBool obj "load-icons-ignoring-image-load-setting"

setSettingsLoadIconsIgnoringImageLoadSetting :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsLoadIconsIgnoringImageLoadSetting obj val = liftIO $ setObjectPropertyBool obj "load-icons-ignoring-image-load-setting" val

constructSettingsLoadIconsIgnoringImageLoadSetting :: Bool -> IO ([Char], GValue)
constructSettingsLoadIconsIgnoringImageLoadSetting val = constructObjectPropertyBool "load-icons-ignoring-image-load-setting" val

data SettingsLoadIconsIgnoringImageLoadSettingPropertyInfo
instance AttrInfo SettingsLoadIconsIgnoringImageLoadSettingPropertyInfo where
    type AttrAllowedOps SettingsLoadIconsIgnoringImageLoadSettingPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsLoadIconsIgnoringImageLoadSettingPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsLoadIconsIgnoringImageLoadSettingPropertyInfo = SettingsK
    type AttrGetType SettingsLoadIconsIgnoringImageLoadSettingPropertyInfo = Bool
    type AttrLabel SettingsLoadIconsIgnoringImageLoadSettingPropertyInfo = "Settings::load-icons-ignoring-image-load-setting"
    attrGet _ = getSettingsLoadIconsIgnoringImageLoadSetting
    attrSet _ = setSettingsLoadIconsIgnoringImageLoadSetting
    attrConstruct _ = constructSettingsLoadIconsIgnoringImageLoadSetting

-- VVV Prop "media-playback-allows-inline"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsMediaPlaybackAllowsInline :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsMediaPlaybackAllowsInline obj = liftIO $ getObjectPropertyBool obj "media-playback-allows-inline"

setSettingsMediaPlaybackAllowsInline :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsMediaPlaybackAllowsInline obj val = liftIO $ setObjectPropertyBool obj "media-playback-allows-inline" val

constructSettingsMediaPlaybackAllowsInline :: Bool -> IO ([Char], GValue)
constructSettingsMediaPlaybackAllowsInline val = constructObjectPropertyBool "media-playback-allows-inline" val

data SettingsMediaPlaybackAllowsInlinePropertyInfo
instance AttrInfo SettingsMediaPlaybackAllowsInlinePropertyInfo where
    type AttrAllowedOps SettingsMediaPlaybackAllowsInlinePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsMediaPlaybackAllowsInlinePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsMediaPlaybackAllowsInlinePropertyInfo = SettingsK
    type AttrGetType SettingsMediaPlaybackAllowsInlinePropertyInfo = Bool
    type AttrLabel SettingsMediaPlaybackAllowsInlinePropertyInfo = "Settings::media-playback-allows-inline"
    attrGet _ = getSettingsMediaPlaybackAllowsInline
    attrSet _ = setSettingsMediaPlaybackAllowsInline
    attrConstruct _ = constructSettingsMediaPlaybackAllowsInline

-- VVV Prop "media-playback-requires-user-gesture"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsMediaPlaybackRequiresUserGesture :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsMediaPlaybackRequiresUserGesture obj = liftIO $ getObjectPropertyBool obj "media-playback-requires-user-gesture"

setSettingsMediaPlaybackRequiresUserGesture :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsMediaPlaybackRequiresUserGesture obj val = liftIO $ setObjectPropertyBool obj "media-playback-requires-user-gesture" val

constructSettingsMediaPlaybackRequiresUserGesture :: Bool -> IO ([Char], GValue)
constructSettingsMediaPlaybackRequiresUserGesture val = constructObjectPropertyBool "media-playback-requires-user-gesture" val

data SettingsMediaPlaybackRequiresUserGesturePropertyInfo
instance AttrInfo SettingsMediaPlaybackRequiresUserGesturePropertyInfo where
    type AttrAllowedOps SettingsMediaPlaybackRequiresUserGesturePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsMediaPlaybackRequiresUserGesturePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsMediaPlaybackRequiresUserGesturePropertyInfo = SettingsK
    type AttrGetType SettingsMediaPlaybackRequiresUserGesturePropertyInfo = Bool
    type AttrLabel SettingsMediaPlaybackRequiresUserGesturePropertyInfo = "Settings::media-playback-requires-user-gesture"
    attrGet _ = getSettingsMediaPlaybackRequiresUserGesture
    attrSet _ = setSettingsMediaPlaybackRequiresUserGesture
    attrConstruct _ = constructSettingsMediaPlaybackRequiresUserGesture

-- VVV Prop "minimum-font-size"
   -- Type: TBasicType TUInt32
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsMinimumFontSize :: (MonadIO m, SettingsK o) => o -> m Word32
getSettingsMinimumFontSize obj = liftIO $ getObjectPropertyCUInt obj "minimum-font-size"

setSettingsMinimumFontSize :: (MonadIO m, SettingsK o) => o -> Word32 -> m ()
setSettingsMinimumFontSize obj val = liftIO $ setObjectPropertyCUInt obj "minimum-font-size" val

constructSettingsMinimumFontSize :: Word32 -> IO ([Char], GValue)
constructSettingsMinimumFontSize val = constructObjectPropertyCUInt "minimum-font-size" val

data SettingsMinimumFontSizePropertyInfo
instance AttrInfo SettingsMinimumFontSizePropertyInfo where
    type AttrAllowedOps SettingsMinimumFontSizePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsMinimumFontSizePropertyInfo = (~) Word32
    type AttrBaseTypeConstraint SettingsMinimumFontSizePropertyInfo = SettingsK
    type AttrGetType SettingsMinimumFontSizePropertyInfo = Word32
    type AttrLabel SettingsMinimumFontSizePropertyInfo = "Settings::minimum-font-size"
    attrGet _ = getSettingsMinimumFontSize
    attrSet _ = setSettingsMinimumFontSize
    attrConstruct _ = constructSettingsMinimumFontSize

-- VVV Prop "monospace-font-family"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsMonospaceFontFamily :: (MonadIO m, SettingsK o) => o -> m T.Text
getSettingsMonospaceFontFamily obj = liftIO $ getObjectPropertyString obj "monospace-font-family"

setSettingsMonospaceFontFamily :: (MonadIO m, SettingsK o) => o -> T.Text -> m ()
setSettingsMonospaceFontFamily obj val = liftIO $ setObjectPropertyString obj "monospace-font-family" val

constructSettingsMonospaceFontFamily :: T.Text -> IO ([Char], GValue)
constructSettingsMonospaceFontFamily val = constructObjectPropertyString "monospace-font-family" val

data SettingsMonospaceFontFamilyPropertyInfo
instance AttrInfo SettingsMonospaceFontFamilyPropertyInfo where
    type AttrAllowedOps SettingsMonospaceFontFamilyPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsMonospaceFontFamilyPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint SettingsMonospaceFontFamilyPropertyInfo = SettingsK
    type AttrGetType SettingsMonospaceFontFamilyPropertyInfo = T.Text
    type AttrLabel SettingsMonospaceFontFamilyPropertyInfo = "Settings::monospace-font-family"
    attrGet _ = getSettingsMonospaceFontFamily
    attrSet _ = setSettingsMonospaceFontFamily
    attrConstruct _ = constructSettingsMonospaceFontFamily

-- VVV Prop "pictograph-font-family"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsPictographFontFamily :: (MonadIO m, SettingsK o) => o -> m T.Text
getSettingsPictographFontFamily obj = liftIO $ getObjectPropertyString obj "pictograph-font-family"

setSettingsPictographFontFamily :: (MonadIO m, SettingsK o) => o -> T.Text -> m ()
setSettingsPictographFontFamily obj val = liftIO $ setObjectPropertyString obj "pictograph-font-family" val

constructSettingsPictographFontFamily :: T.Text -> IO ([Char], GValue)
constructSettingsPictographFontFamily val = constructObjectPropertyString "pictograph-font-family" val

data SettingsPictographFontFamilyPropertyInfo
instance AttrInfo SettingsPictographFontFamilyPropertyInfo where
    type AttrAllowedOps SettingsPictographFontFamilyPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsPictographFontFamilyPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint SettingsPictographFontFamilyPropertyInfo = SettingsK
    type AttrGetType SettingsPictographFontFamilyPropertyInfo = T.Text
    type AttrLabel SettingsPictographFontFamilyPropertyInfo = "Settings::pictograph-font-family"
    attrGet _ = getSettingsPictographFontFamily
    attrSet _ = setSettingsPictographFontFamily
    attrConstruct _ = constructSettingsPictographFontFamily

-- VVV Prop "print-backgrounds"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsPrintBackgrounds :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsPrintBackgrounds obj = liftIO $ getObjectPropertyBool obj "print-backgrounds"

setSettingsPrintBackgrounds :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsPrintBackgrounds obj val = liftIO $ setObjectPropertyBool obj "print-backgrounds" val

constructSettingsPrintBackgrounds :: Bool -> IO ([Char], GValue)
constructSettingsPrintBackgrounds val = constructObjectPropertyBool "print-backgrounds" val

data SettingsPrintBackgroundsPropertyInfo
instance AttrInfo SettingsPrintBackgroundsPropertyInfo where
    type AttrAllowedOps SettingsPrintBackgroundsPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsPrintBackgroundsPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsPrintBackgroundsPropertyInfo = SettingsK
    type AttrGetType SettingsPrintBackgroundsPropertyInfo = Bool
    type AttrLabel SettingsPrintBackgroundsPropertyInfo = "Settings::print-backgrounds"
    attrGet _ = getSettingsPrintBackgrounds
    attrSet _ = setSettingsPrintBackgrounds
    attrConstruct _ = constructSettingsPrintBackgrounds

-- VVV Prop "sans-serif-font-family"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsSansSerifFontFamily :: (MonadIO m, SettingsK o) => o -> m T.Text
getSettingsSansSerifFontFamily obj = liftIO $ getObjectPropertyString obj "sans-serif-font-family"

setSettingsSansSerifFontFamily :: (MonadIO m, SettingsK o) => o -> T.Text -> m ()
setSettingsSansSerifFontFamily obj val = liftIO $ setObjectPropertyString obj "sans-serif-font-family" val

constructSettingsSansSerifFontFamily :: T.Text -> IO ([Char], GValue)
constructSettingsSansSerifFontFamily val = constructObjectPropertyString "sans-serif-font-family" val

data SettingsSansSerifFontFamilyPropertyInfo
instance AttrInfo SettingsSansSerifFontFamilyPropertyInfo where
    type AttrAllowedOps SettingsSansSerifFontFamilyPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsSansSerifFontFamilyPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint SettingsSansSerifFontFamilyPropertyInfo = SettingsK
    type AttrGetType SettingsSansSerifFontFamilyPropertyInfo = T.Text
    type AttrLabel SettingsSansSerifFontFamilyPropertyInfo = "Settings::sans-serif-font-family"
    attrGet _ = getSettingsSansSerifFontFamily
    attrSet _ = setSettingsSansSerifFontFamily
    attrConstruct _ = constructSettingsSansSerifFontFamily

-- VVV Prop "serif-font-family"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsSerifFontFamily :: (MonadIO m, SettingsK o) => o -> m T.Text
getSettingsSerifFontFamily obj = liftIO $ getObjectPropertyString obj "serif-font-family"

setSettingsSerifFontFamily :: (MonadIO m, SettingsK o) => o -> T.Text -> m ()
setSettingsSerifFontFamily obj val = liftIO $ setObjectPropertyString obj "serif-font-family" val

constructSettingsSerifFontFamily :: T.Text -> IO ([Char], GValue)
constructSettingsSerifFontFamily val = constructObjectPropertyString "serif-font-family" val

data SettingsSerifFontFamilyPropertyInfo
instance AttrInfo SettingsSerifFontFamilyPropertyInfo where
    type AttrAllowedOps SettingsSerifFontFamilyPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsSerifFontFamilyPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint SettingsSerifFontFamilyPropertyInfo = SettingsK
    type AttrGetType SettingsSerifFontFamilyPropertyInfo = T.Text
    type AttrLabel SettingsSerifFontFamilyPropertyInfo = "Settings::serif-font-family"
    attrGet _ = getSettingsSerifFontFamily
    attrSet _ = setSettingsSerifFontFamily
    attrConstruct _ = constructSettingsSerifFontFamily

-- VVV Prop "user-agent"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsUserAgent :: (MonadIO m, SettingsK o) => o -> m T.Text
getSettingsUserAgent obj = liftIO $ getObjectPropertyString obj "user-agent"

setSettingsUserAgent :: (MonadIO m, SettingsK o) => o -> T.Text -> m ()
setSettingsUserAgent obj val = liftIO $ setObjectPropertyString obj "user-agent" val

constructSettingsUserAgent :: T.Text -> IO ([Char], GValue)
constructSettingsUserAgent val = constructObjectPropertyString "user-agent" val

data SettingsUserAgentPropertyInfo
instance AttrInfo SettingsUserAgentPropertyInfo where
    type AttrAllowedOps SettingsUserAgentPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsUserAgentPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint SettingsUserAgentPropertyInfo = SettingsK
    type AttrGetType SettingsUserAgentPropertyInfo = T.Text
    type AttrLabel SettingsUserAgentPropertyInfo = "Settings::user-agent"
    attrGet _ = getSettingsUserAgent
    attrSet _ = setSettingsUserAgent
    attrConstruct _ = constructSettingsUserAgent

-- VVV Prop "zoom-text-only"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getSettingsZoomTextOnly :: (MonadIO m, SettingsK o) => o -> m Bool
getSettingsZoomTextOnly obj = liftIO $ getObjectPropertyBool obj "zoom-text-only"

setSettingsZoomTextOnly :: (MonadIO m, SettingsK o) => o -> Bool -> m ()
setSettingsZoomTextOnly obj val = liftIO $ setObjectPropertyBool obj "zoom-text-only" val

constructSettingsZoomTextOnly :: Bool -> IO ([Char], GValue)
constructSettingsZoomTextOnly val = constructObjectPropertyBool "zoom-text-only" val

data SettingsZoomTextOnlyPropertyInfo
instance AttrInfo SettingsZoomTextOnlyPropertyInfo where
    type AttrAllowedOps SettingsZoomTextOnlyPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint SettingsZoomTextOnlyPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint SettingsZoomTextOnlyPropertyInfo = SettingsK
    type AttrGetType SettingsZoomTextOnlyPropertyInfo = Bool
    type AttrLabel SettingsZoomTextOnlyPropertyInfo = "Settings::zoom-text-only"
    attrGet _ = getSettingsZoomTextOnly
    attrSet _ = setSettingsZoomTextOnly
    attrConstruct _ = constructSettingsZoomTextOnly

type instance AttributeList Settings = '[ '("allow-file-access-from-file-urls", SettingsAllowFileAccessFromFileUrlsPropertyInfo), '("allow-modal-dialogs", SettingsAllowModalDialogsPropertyInfo), '("auto-load-images", SettingsAutoLoadImagesPropertyInfo), '("cursive-font-family", SettingsCursiveFontFamilyPropertyInfo), '("default-charset", SettingsDefaultCharsetPropertyInfo), '("default-font-family", SettingsDefaultFontFamilyPropertyInfo), '("default-font-size", SettingsDefaultFontSizePropertyInfo), '("default-monospace-font-size", SettingsDefaultMonospaceFontSizePropertyInfo), '("draw-compositing-indicators", SettingsDrawCompositingIndicatorsPropertyInfo), '("enable-accelerated-2d-canvas", SettingsEnableAccelerated2dCanvasPropertyInfo), '("enable-caret-browsing", SettingsEnableCaretBrowsingPropertyInfo), '("enable-developer-extras", SettingsEnableDeveloperExtrasPropertyInfo), '("enable-dns-prefetching", SettingsEnableDnsPrefetchingPropertyInfo), '("enable-frame-flattening", SettingsEnableFrameFlatteningPropertyInfo), '("enable-fullscreen", SettingsEnableFullscreenPropertyInfo), '("enable-html5-database", SettingsEnableHtml5DatabasePropertyInfo), '("enable-html5-local-storage", SettingsEnableHtml5LocalStoragePropertyInfo), '("enable-hyperlink-auditing", SettingsEnableHyperlinkAuditingPropertyInfo), '("enable-java", SettingsEnableJavaPropertyInfo), '("enable-javascript", SettingsEnableJavascriptPropertyInfo), '("enable-media-stream", SettingsEnableMediaStreamPropertyInfo), '("enable-mediasource", SettingsEnableMediasourcePropertyInfo), '("enable-offline-web-application-cache", SettingsEnableOfflineWebApplicationCachePropertyInfo), '("enable-page-cache", SettingsEnablePageCachePropertyInfo), '("enable-plugins", SettingsEnablePluginsPropertyInfo), '("enable-private-browsing", SettingsEnablePrivateBrowsingPropertyInfo), '("enable-resizable-text-areas", SettingsEnableResizableTextAreasPropertyInfo), '("enable-site-specific-quirks", SettingsEnableSiteSpecificQuirksPropertyInfo), '("enable-smooth-scrolling", SettingsEnableSmoothScrollingPropertyInfo), '("enable-spatial-navigation", SettingsEnableSpatialNavigationPropertyInfo), '("enable-tabs-to-links", SettingsEnableTabsToLinksPropertyInfo), '("enable-webaudio", SettingsEnableWebaudioPropertyInfo), '("enable-webgl", SettingsEnableWebglPropertyInfo), '("enable-write-console-messages-to-stdout", SettingsEnableWriteConsoleMessagesToStdoutPropertyInfo), '("enable-xss-auditor", SettingsEnableXssAuditorPropertyInfo), '("fantasy-font-family", SettingsFantasyFontFamilyPropertyInfo), '("javascript-can-access-clipboard", SettingsJavascriptCanAccessClipboardPropertyInfo), '("javascript-can-open-windows-automatically", SettingsJavascriptCanOpenWindowsAutomaticallyPropertyInfo), '("load-icons-ignoring-image-load-setting", SettingsLoadIconsIgnoringImageLoadSettingPropertyInfo), '("media-playback-allows-inline", SettingsMediaPlaybackAllowsInlinePropertyInfo), '("media-playback-requires-user-gesture", SettingsMediaPlaybackRequiresUserGesturePropertyInfo), '("minimum-font-size", SettingsMinimumFontSizePropertyInfo), '("monospace-font-family", SettingsMonospaceFontFamilyPropertyInfo), '("pictograph-font-family", SettingsPictographFontFamilyPropertyInfo), '("print-backgrounds", SettingsPrintBackgroundsPropertyInfo), '("sans-serif-font-family", SettingsSansSerifFontFamilyPropertyInfo), '("serif-font-family", SettingsSerifFontFamilyPropertyInfo), '("user-agent", SettingsUserAgentPropertyInfo), '("zoom-text-only", SettingsZoomTextOnlyPropertyInfo)]

-- VVV Prop "uri"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]

getURIRequestUri :: (MonadIO m, URIRequestK o) => o -> m T.Text
getURIRequestUri obj = liftIO $ getObjectPropertyString obj "uri"

setURIRequestUri :: (MonadIO m, URIRequestK o) => o -> T.Text -> m ()
setURIRequestUri obj val = liftIO $ setObjectPropertyString obj "uri" val

constructURIRequestUri :: T.Text -> IO ([Char], GValue)
constructURIRequestUri val = constructObjectPropertyString "uri" val

data URIRequestUriPropertyInfo
instance AttrInfo URIRequestUriPropertyInfo where
    type AttrAllowedOps URIRequestUriPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint URIRequestUriPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint URIRequestUriPropertyInfo = URIRequestK
    type AttrGetType URIRequestUriPropertyInfo = T.Text
    type AttrLabel URIRequestUriPropertyInfo = "URIRequest::uri"
    attrGet _ = getURIRequestUri
    attrSet _ = setURIRequestUri
    attrConstruct _ = constructURIRequestUri

type instance AttributeList URIRequest = '[ '("uri", URIRequestUriPropertyInfo)]

-- VVV Prop "content-length"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable]

getURIResponseContentLength :: (MonadIO m, URIResponseK o) => o -> m Word64
getURIResponseContentLength obj = liftIO $ getObjectPropertyUInt64 obj "content-length"

data URIResponseContentLengthPropertyInfo
instance AttrInfo URIResponseContentLengthPropertyInfo where
    type AttrAllowedOps URIResponseContentLengthPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint URIResponseContentLengthPropertyInfo = (~) ()
    type AttrBaseTypeConstraint URIResponseContentLengthPropertyInfo = URIResponseK
    type AttrGetType URIResponseContentLengthPropertyInfo = Word64
    type AttrLabel URIResponseContentLengthPropertyInfo = "URIResponse::content-length"
    attrGet _ = getURIResponseContentLength
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "http-headers"
   -- Type: TInterface "Soup" "MessageHeaders"
   -- Flags: [PropertyReadable]

getURIResponseHttpHeaders :: (MonadIO m, URIResponseK o) => o -> m Soup.MessageHeaders
getURIResponseHttpHeaders obj = liftIO $ getObjectPropertyBoxed obj "http-headers" Soup.MessageHeaders

data URIResponseHttpHeadersPropertyInfo
instance AttrInfo URIResponseHttpHeadersPropertyInfo where
    type AttrAllowedOps URIResponseHttpHeadersPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint URIResponseHttpHeadersPropertyInfo = (~) ()
    type AttrBaseTypeConstraint URIResponseHttpHeadersPropertyInfo = URIResponseK
    type AttrGetType URIResponseHttpHeadersPropertyInfo = Soup.MessageHeaders
    type AttrLabel URIResponseHttpHeadersPropertyInfo = "URIResponse::http-headers"
    attrGet _ = getURIResponseHttpHeaders
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "mime-type"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getURIResponseMimeType :: (MonadIO m, URIResponseK o) => o -> m T.Text
getURIResponseMimeType obj = liftIO $ getObjectPropertyString obj "mime-type"

data URIResponseMimeTypePropertyInfo
instance AttrInfo URIResponseMimeTypePropertyInfo where
    type AttrAllowedOps URIResponseMimeTypePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint URIResponseMimeTypePropertyInfo = (~) ()
    type AttrBaseTypeConstraint URIResponseMimeTypePropertyInfo = URIResponseK
    type AttrGetType URIResponseMimeTypePropertyInfo = T.Text
    type AttrLabel URIResponseMimeTypePropertyInfo = "URIResponse::mime-type"
    attrGet _ = getURIResponseMimeType
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "status-code"
   -- Type: TBasicType TUInt32
   -- Flags: [PropertyReadable]

getURIResponseStatusCode :: (MonadIO m, URIResponseK o) => o -> m Word32
getURIResponseStatusCode obj = liftIO $ getObjectPropertyCUInt obj "status-code"

data URIResponseStatusCodePropertyInfo
instance AttrInfo URIResponseStatusCodePropertyInfo where
    type AttrAllowedOps URIResponseStatusCodePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint URIResponseStatusCodePropertyInfo = (~) ()
    type AttrBaseTypeConstraint URIResponseStatusCodePropertyInfo = URIResponseK
    type AttrGetType URIResponseStatusCodePropertyInfo = Word32
    type AttrLabel URIResponseStatusCodePropertyInfo = "URIResponse::status-code"
    attrGet _ = getURIResponseStatusCode
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "suggested-filename"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getURIResponseSuggestedFilename :: (MonadIO m, URIResponseK o) => o -> m T.Text
getURIResponseSuggestedFilename obj = liftIO $ getObjectPropertyString obj "suggested-filename"

data URIResponseSuggestedFilenamePropertyInfo
instance AttrInfo URIResponseSuggestedFilenamePropertyInfo where
    type AttrAllowedOps URIResponseSuggestedFilenamePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint URIResponseSuggestedFilenamePropertyInfo = (~) ()
    type AttrBaseTypeConstraint URIResponseSuggestedFilenamePropertyInfo = URIResponseK
    type AttrGetType URIResponseSuggestedFilenamePropertyInfo = T.Text
    type AttrLabel URIResponseSuggestedFilenamePropertyInfo = "URIResponse::suggested-filename"
    attrGet _ = getURIResponseSuggestedFilename
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "uri"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getURIResponseUri :: (MonadIO m, URIResponseK o) => o -> m T.Text
getURIResponseUri obj = liftIO $ getObjectPropertyString obj "uri"

data URIResponseUriPropertyInfo
instance AttrInfo URIResponseUriPropertyInfo where
    type AttrAllowedOps URIResponseUriPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint URIResponseUriPropertyInfo = (~) ()
    type AttrBaseTypeConstraint URIResponseUriPropertyInfo = URIResponseK
    type AttrGetType URIResponseUriPropertyInfo = T.Text
    type AttrLabel URIResponseUriPropertyInfo = "URIResponse::uri"
    attrGet _ = getURIResponseUri
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList URIResponse = '[ '("content-length", URIResponseContentLengthPropertyInfo), '("http-headers", URIResponseHttpHeadersPropertyInfo), '("mime-type", URIResponseMimeTypePropertyInfo), '("status-code", URIResponseStatusCodePropertyInfo), '("suggested-filename", URIResponseSuggestedFilenamePropertyInfo), '("uri", URIResponseUriPropertyInfo)]

type instance AttributeList URISchemeRequest = '[ ]

type instance AttributeList UserContentManager = '[ ]

-- VVV Prop "is-for-audio-device"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getUserMediaPermissionRequestIsForAudioDevice :: (MonadIO m, UserMediaPermissionRequestK o) => o -> m Bool
getUserMediaPermissionRequestIsForAudioDevice obj = liftIO $ getObjectPropertyBool obj "is-for-audio-device"

data UserMediaPermissionRequestIsForAudioDevicePropertyInfo
instance AttrInfo UserMediaPermissionRequestIsForAudioDevicePropertyInfo where
    type AttrAllowedOps UserMediaPermissionRequestIsForAudioDevicePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint UserMediaPermissionRequestIsForAudioDevicePropertyInfo = (~) ()
    type AttrBaseTypeConstraint UserMediaPermissionRequestIsForAudioDevicePropertyInfo = UserMediaPermissionRequestK
    type AttrGetType UserMediaPermissionRequestIsForAudioDevicePropertyInfo = Bool
    type AttrLabel UserMediaPermissionRequestIsForAudioDevicePropertyInfo = "UserMediaPermissionRequest::is-for-audio-device"
    attrGet _ = getUserMediaPermissionRequestIsForAudioDevice
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "is-for-video-device"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getUserMediaPermissionRequestIsForVideoDevice :: (MonadIO m, UserMediaPermissionRequestK o) => o -> m Bool
getUserMediaPermissionRequestIsForVideoDevice obj = liftIO $ getObjectPropertyBool obj "is-for-video-device"

data UserMediaPermissionRequestIsForVideoDevicePropertyInfo
instance AttrInfo UserMediaPermissionRequestIsForVideoDevicePropertyInfo where
    type AttrAllowedOps UserMediaPermissionRequestIsForVideoDevicePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint UserMediaPermissionRequestIsForVideoDevicePropertyInfo = (~) ()
    type AttrBaseTypeConstraint UserMediaPermissionRequestIsForVideoDevicePropertyInfo = UserMediaPermissionRequestK
    type AttrGetType UserMediaPermissionRequestIsForVideoDevicePropertyInfo = Bool
    type AttrLabel UserMediaPermissionRequestIsForVideoDevicePropertyInfo = "UserMediaPermissionRequest::is-for-video-device"
    attrGet _ = getUserMediaPermissionRequestIsForVideoDevice
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList UserMediaPermissionRequest = '[ '("is-for-audio-device", UserMediaPermissionRequestIsForAudioDevicePropertyInfo), '("is-for-video-device", UserMediaPermissionRequestIsForVideoDevicePropertyInfo)]

-- VVV Prop "local-storage-directory"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getWebContextLocalStorageDirectory :: (MonadIO m, WebContextK o) => o -> m T.Text
getWebContextLocalStorageDirectory obj = liftIO $ getObjectPropertyString obj "local-storage-directory"

constructWebContextLocalStorageDirectory :: T.Text -> IO ([Char], GValue)
constructWebContextLocalStorageDirectory val = constructObjectPropertyString "local-storage-directory" val

data WebContextLocalStorageDirectoryPropertyInfo
instance AttrInfo WebContextLocalStorageDirectoryPropertyInfo where
    type AttrAllowedOps WebContextLocalStorageDirectoryPropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint WebContextLocalStorageDirectoryPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint WebContextLocalStorageDirectoryPropertyInfo = WebContextK
    type AttrGetType WebContextLocalStorageDirectoryPropertyInfo = T.Text
    type AttrLabel WebContextLocalStorageDirectoryPropertyInfo = "WebContext::local-storage-directory"
    attrGet _ = getWebContextLocalStorageDirectory
    attrSet _ = undefined
    attrConstruct _ = constructWebContextLocalStorageDirectory

-- VVV Prop "website-data-manager"
   -- Type: TInterface "WebKit2" "WebsiteDataManager"
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getWebContextWebsiteDataManager :: (MonadIO m, WebContextK o) => o -> m WebsiteDataManager
getWebContextWebsiteDataManager obj = liftIO $ getObjectPropertyObject obj "website-data-manager" WebsiteDataManager

constructWebContextWebsiteDataManager :: (WebsiteDataManagerK a) => a -> IO ([Char], GValue)
constructWebContextWebsiteDataManager val = constructObjectPropertyObject "website-data-manager" val

data WebContextWebsiteDataManagerPropertyInfo
instance AttrInfo WebContextWebsiteDataManagerPropertyInfo where
    type AttrAllowedOps WebContextWebsiteDataManagerPropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint WebContextWebsiteDataManagerPropertyInfo = WebsiteDataManagerK
    type AttrBaseTypeConstraint WebContextWebsiteDataManagerPropertyInfo = WebContextK
    type AttrGetType WebContextWebsiteDataManagerPropertyInfo = WebsiteDataManager
    type AttrLabel WebContextWebsiteDataManagerPropertyInfo = "WebContext::website-data-manager"
    attrGet _ = getWebContextWebsiteDataManager
    attrSet _ = undefined
    attrConstruct _ = constructWebContextWebsiteDataManager

type instance AttributeList WebContext = '[ '("local-storage-directory", WebContextLocalStorageDirectoryPropertyInfo), '("website-data-manager", WebContextWebsiteDataManagerPropertyInfo)]

-- VVV Prop "attached-height"
   -- Type: TBasicType TUInt32
   -- Flags: [PropertyReadable]

getWebInspectorAttachedHeight :: (MonadIO m, WebInspectorK o) => o -> m Word32
getWebInspectorAttachedHeight obj = liftIO $ getObjectPropertyCUInt obj "attached-height"

data WebInspectorAttachedHeightPropertyInfo
instance AttrInfo WebInspectorAttachedHeightPropertyInfo where
    type AttrAllowedOps WebInspectorAttachedHeightPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint WebInspectorAttachedHeightPropertyInfo = (~) ()
    type AttrBaseTypeConstraint WebInspectorAttachedHeightPropertyInfo = WebInspectorK
    type AttrGetType WebInspectorAttachedHeightPropertyInfo = Word32
    type AttrLabel WebInspectorAttachedHeightPropertyInfo = "WebInspector::attached-height"
    attrGet _ = getWebInspectorAttachedHeight
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "can-attach"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getWebInspectorCanAttach :: (MonadIO m, WebInspectorK o) => o -> m Bool
getWebInspectorCanAttach obj = liftIO $ getObjectPropertyBool obj "can-attach"

data WebInspectorCanAttachPropertyInfo
instance AttrInfo WebInspectorCanAttachPropertyInfo where
    type AttrAllowedOps WebInspectorCanAttachPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint WebInspectorCanAttachPropertyInfo = (~) ()
    type AttrBaseTypeConstraint WebInspectorCanAttachPropertyInfo = WebInspectorK
    type AttrGetType WebInspectorCanAttachPropertyInfo = Bool
    type AttrLabel WebInspectorCanAttachPropertyInfo = "WebInspector::can-attach"
    attrGet _ = getWebInspectorCanAttach
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "inspected-uri"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getWebInspectorInspectedUri :: (MonadIO m, WebInspectorK o) => o -> m T.Text
getWebInspectorInspectedUri obj = liftIO $ getObjectPropertyString obj "inspected-uri"

data WebInspectorInspectedUriPropertyInfo
instance AttrInfo WebInspectorInspectedUriPropertyInfo where
    type AttrAllowedOps WebInspectorInspectedUriPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint WebInspectorInspectedUriPropertyInfo = (~) ()
    type AttrBaseTypeConstraint WebInspectorInspectedUriPropertyInfo = WebInspectorK
    type AttrGetType WebInspectorInspectedUriPropertyInfo = T.Text
    type AttrLabel WebInspectorInspectedUriPropertyInfo = "WebInspector::inspected-uri"
    attrGet _ = getWebInspectorInspectedUri
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList WebInspector = '[ '("attached-height", WebInspectorAttachedHeightPropertyInfo), '("can-attach", WebInspectorCanAttachPropertyInfo), '("inspected-uri", WebInspectorInspectedUriPropertyInfo)]

-- VVV Prop "response"
   -- Type: TInterface "WebKit2" "URIResponse"
   -- Flags: [PropertyReadable]

getWebResourceResponse :: (MonadIO m, WebResourceK o) => o -> m URIResponse
getWebResourceResponse obj = liftIO $ getObjectPropertyObject obj "response" URIResponse

data WebResourceResponsePropertyInfo
instance AttrInfo WebResourceResponsePropertyInfo where
    type AttrAllowedOps WebResourceResponsePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint WebResourceResponsePropertyInfo = (~) ()
    type AttrBaseTypeConstraint WebResourceResponsePropertyInfo = WebResourceK
    type AttrGetType WebResourceResponsePropertyInfo = URIResponse
    type AttrLabel WebResourceResponsePropertyInfo = "WebResource::response"
    attrGet _ = getWebResourceResponse
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "uri"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getWebResourceUri :: (MonadIO m, WebResourceK o) => o -> m T.Text
getWebResourceUri obj = liftIO $ getObjectPropertyString obj "uri"

data WebResourceUriPropertyInfo
instance AttrInfo WebResourceUriPropertyInfo where
    type AttrAllowedOps WebResourceUriPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint WebResourceUriPropertyInfo = (~) ()
    type AttrBaseTypeConstraint WebResourceUriPropertyInfo = WebResourceK
    type AttrGetType WebResourceUriPropertyInfo = T.Text
    type AttrLabel WebResourceUriPropertyInfo = "WebResource::uri"
    attrGet _ = getWebResourceUri
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList WebResource = '[ '("response", WebResourceResponsePropertyInfo), '("uri", WebResourceUriPropertyInfo)]

-- VVV Prop "editable"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getWebViewEditable :: (MonadIO m, WebViewK o) => o -> m Bool
getWebViewEditable obj = liftIO $ getObjectPropertyBool obj "editable"

setWebViewEditable :: (MonadIO m, WebViewK o) => o -> Bool -> m ()
setWebViewEditable obj val = liftIO $ setObjectPropertyBool obj "editable" val

constructWebViewEditable :: Bool -> IO ([Char], GValue)
constructWebViewEditable val = constructObjectPropertyBool "editable" val

data WebViewEditablePropertyInfo
instance AttrInfo WebViewEditablePropertyInfo where
    type AttrAllowedOps WebViewEditablePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint WebViewEditablePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint WebViewEditablePropertyInfo = WebViewK
    type AttrGetType WebViewEditablePropertyInfo = Bool
    type AttrLabel WebViewEditablePropertyInfo = "WebView::editable"
    attrGet _ = getWebViewEditable
    attrSet _ = setWebViewEditable
    attrConstruct _ = constructWebViewEditable

-- VVV Prop "estimated-load-progress"
   -- Type: TBasicType TDouble
   -- Flags: [PropertyReadable]

getWebViewEstimatedLoadProgress :: (MonadIO m, WebViewK o) => o -> m Double
getWebViewEstimatedLoadProgress obj = liftIO $ getObjectPropertyDouble obj "estimated-load-progress"

data WebViewEstimatedLoadProgressPropertyInfo
instance AttrInfo WebViewEstimatedLoadProgressPropertyInfo where
    type AttrAllowedOps WebViewEstimatedLoadProgressPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint WebViewEstimatedLoadProgressPropertyInfo = (~) ()
    type AttrBaseTypeConstraint WebViewEstimatedLoadProgressPropertyInfo = WebViewK
    type AttrGetType WebViewEstimatedLoadProgressPropertyInfo = Double
    type AttrLabel WebViewEstimatedLoadProgressPropertyInfo = "WebView::estimated-load-progress"
    attrGet _ = getWebViewEstimatedLoadProgress
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "favicon"
   -- Type: TBasicType TVoid
   -- Flags: [PropertyReadable]

getWebViewFavicon :: (MonadIO m, WebViewK o) => o -> m (Ptr ())
getWebViewFavicon obj = liftIO $ getObjectPropertyPtr obj "favicon"

data WebViewFaviconPropertyInfo
instance AttrInfo WebViewFaviconPropertyInfo where
    type AttrAllowedOps WebViewFaviconPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint WebViewFaviconPropertyInfo = (~) ()
    type AttrBaseTypeConstraint WebViewFaviconPropertyInfo = WebViewK
    type AttrGetType WebViewFaviconPropertyInfo = (Ptr ())
    type AttrLabel WebViewFaviconPropertyInfo = "WebView::favicon"
    attrGet _ = getWebViewFavicon
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "is-loading"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getWebViewIsLoading :: (MonadIO m, WebViewK o) => o -> m Bool
getWebViewIsLoading obj = liftIO $ getObjectPropertyBool obj "is-loading"

data WebViewIsLoadingPropertyInfo
instance AttrInfo WebViewIsLoadingPropertyInfo where
    type AttrAllowedOps WebViewIsLoadingPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint WebViewIsLoadingPropertyInfo = (~) ()
    type AttrBaseTypeConstraint WebViewIsLoadingPropertyInfo = WebViewK
    type AttrGetType WebViewIsLoadingPropertyInfo = Bool
    type AttrLabel WebViewIsLoadingPropertyInfo = "WebView::is-loading"
    attrGet _ = getWebViewIsLoading
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "is-playing-audio"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getWebViewIsPlayingAudio :: (MonadIO m, WebViewK o) => o -> m Bool
getWebViewIsPlayingAudio obj = liftIO $ getObjectPropertyBool obj "is-playing-audio"

data WebViewIsPlayingAudioPropertyInfo
instance AttrInfo WebViewIsPlayingAudioPropertyInfo where
    type AttrAllowedOps WebViewIsPlayingAudioPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint WebViewIsPlayingAudioPropertyInfo = (~) ()
    type AttrBaseTypeConstraint WebViewIsPlayingAudioPropertyInfo = WebViewK
    type AttrGetType WebViewIsPlayingAudioPropertyInfo = Bool
    type AttrLabel WebViewIsPlayingAudioPropertyInfo = "WebView::is-playing-audio"
    attrGet _ = getWebViewIsPlayingAudio
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "related-view"
   -- Type: TInterface "WebKit2" "WebView"
   -- Flags: [PropertyWritable,PropertyConstructOnly]

constructWebViewRelatedView :: (WebViewK a) => a -> IO ([Char], GValue)
constructWebViewRelatedView val = constructObjectPropertyObject "related-view" val

data WebViewRelatedViewPropertyInfo
instance AttrInfo WebViewRelatedViewPropertyInfo where
    type AttrAllowedOps WebViewRelatedViewPropertyInfo = '[ 'AttrConstruct]
    type AttrSetTypeConstraint WebViewRelatedViewPropertyInfo = WebViewK
    type AttrBaseTypeConstraint WebViewRelatedViewPropertyInfo = WebViewK
    type AttrGetType WebViewRelatedViewPropertyInfo = ()
    type AttrLabel WebViewRelatedViewPropertyInfo = "WebView::related-view"
    attrGet _ = undefined
    attrSet _ = undefined
    attrConstruct _ = constructWebViewRelatedView

-- VVV Prop "settings"
   -- Type: TInterface "WebKit2" "Settings"
   -- Flags: [PropertyWritable,PropertyConstruct]

setWebViewSettings :: (MonadIO m, WebViewK o, SettingsK a) => o -> a -> m ()
setWebViewSettings obj val = liftIO $ setObjectPropertyObject obj "settings" val

constructWebViewSettings :: (SettingsK a) => a -> IO ([Char], GValue)
constructWebViewSettings val = constructObjectPropertyObject "settings" val

data WebViewSettingsPropertyInfo
instance AttrInfo WebViewSettingsPropertyInfo where
    type AttrAllowedOps WebViewSettingsPropertyInfo = '[ 'AttrSet, 'AttrConstruct]
    type AttrSetTypeConstraint WebViewSettingsPropertyInfo = SettingsK
    type AttrBaseTypeConstraint WebViewSettingsPropertyInfo = WebViewK
    type AttrGetType WebViewSettingsPropertyInfo = ()
    type AttrLabel WebViewSettingsPropertyInfo = "WebView::settings"
    attrGet _ = undefined
    attrSet _ = setWebViewSettings
    attrConstruct _ = constructWebViewSettings

-- VVV Prop "title"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getWebViewTitle :: (MonadIO m, WebViewK o) => o -> m T.Text
getWebViewTitle obj = liftIO $ getObjectPropertyString obj "title"

data WebViewTitlePropertyInfo
instance AttrInfo WebViewTitlePropertyInfo where
    type AttrAllowedOps WebViewTitlePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint WebViewTitlePropertyInfo = (~) ()
    type AttrBaseTypeConstraint WebViewTitlePropertyInfo = WebViewK
    type AttrGetType WebViewTitlePropertyInfo = T.Text
    type AttrLabel WebViewTitlePropertyInfo = "WebView::title"
    attrGet _ = getWebViewTitle
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "uri"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getWebViewUri :: (MonadIO m, WebViewK o) => o -> m T.Text
getWebViewUri obj = liftIO $ getObjectPropertyString obj "uri"

data WebViewUriPropertyInfo
instance AttrInfo WebViewUriPropertyInfo where
    type AttrAllowedOps WebViewUriPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint WebViewUriPropertyInfo = (~) ()
    type AttrBaseTypeConstraint WebViewUriPropertyInfo = WebViewK
    type AttrGetType WebViewUriPropertyInfo = T.Text
    type AttrLabel WebViewUriPropertyInfo = "WebView::uri"
    attrGet _ = getWebViewUri
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "user-content-manager"
   -- Type: TInterface "WebKit2" "UserContentManager"
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getWebViewUserContentManager :: (MonadIO m, WebViewK o) => o -> m UserContentManager
getWebViewUserContentManager obj = liftIO $ getObjectPropertyObject obj "user-content-manager" UserContentManager

constructWebViewUserContentManager :: (UserContentManagerK a) => a -> IO ([Char], GValue)
constructWebViewUserContentManager val = constructObjectPropertyObject "user-content-manager" val

data WebViewUserContentManagerPropertyInfo
instance AttrInfo WebViewUserContentManagerPropertyInfo where
    type AttrAllowedOps WebViewUserContentManagerPropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint WebViewUserContentManagerPropertyInfo = UserContentManagerK
    type AttrBaseTypeConstraint WebViewUserContentManagerPropertyInfo = WebViewK
    type AttrGetType WebViewUserContentManagerPropertyInfo = UserContentManager
    type AttrLabel WebViewUserContentManagerPropertyInfo = "WebView::user-content-manager"
    attrGet _ = getWebViewUserContentManager
    attrSet _ = undefined
    attrConstruct _ = constructWebViewUserContentManager

-- VVV Prop "web-context"
   -- Type: TInterface "WebKit2" "WebContext"
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getWebViewWebContext :: (MonadIO m, WebViewK o) => o -> m WebContext
getWebViewWebContext obj = liftIO $ getObjectPropertyObject obj "web-context" WebContext

constructWebViewWebContext :: (WebContextK a) => a -> IO ([Char], GValue)
constructWebViewWebContext val = constructObjectPropertyObject "web-context" val

data WebViewWebContextPropertyInfo
instance AttrInfo WebViewWebContextPropertyInfo where
    type AttrAllowedOps WebViewWebContextPropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint WebViewWebContextPropertyInfo = WebContextK
    type AttrBaseTypeConstraint WebViewWebContextPropertyInfo = WebViewK
    type AttrGetType WebViewWebContextPropertyInfo = WebContext
    type AttrLabel WebViewWebContextPropertyInfo = "WebView::web-context"
    attrGet _ = getWebViewWebContext
    attrSet _ = undefined
    attrConstruct _ = constructWebViewWebContext

-- VVV Prop "zoom-level"
   -- Type: TBasicType TDouble
   -- Flags: [PropertyReadable,PropertyWritable]

getWebViewZoomLevel :: (MonadIO m, WebViewK o) => o -> m Double
getWebViewZoomLevel obj = liftIO $ getObjectPropertyDouble obj "zoom-level"

setWebViewZoomLevel :: (MonadIO m, WebViewK o) => o -> Double -> m ()
setWebViewZoomLevel obj val = liftIO $ setObjectPropertyDouble obj "zoom-level" val

constructWebViewZoomLevel :: Double -> IO ([Char], GValue)
constructWebViewZoomLevel val = constructObjectPropertyDouble "zoom-level" val

data WebViewZoomLevelPropertyInfo
instance AttrInfo WebViewZoomLevelPropertyInfo where
    type AttrAllowedOps WebViewZoomLevelPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint WebViewZoomLevelPropertyInfo = (~) Double
    type AttrBaseTypeConstraint WebViewZoomLevelPropertyInfo = WebViewK
    type AttrGetType WebViewZoomLevelPropertyInfo = Double
    type AttrLabel WebViewZoomLevelPropertyInfo = "WebView::zoom-level"
    attrGet _ = getWebViewZoomLevel
    attrSet _ = setWebViewZoomLevel
    attrConstruct _ = constructWebViewZoomLevel

type instance AttributeList WebView = '[ '("app-paintable", GtkA.WidgetAppPaintablePropertyInfo), '("border-width", GtkA.ContainerBorderWidthPropertyInfo), '("can-default", GtkA.WidgetCanDefaultPropertyInfo), '("can-focus", GtkA.WidgetCanFocusPropertyInfo), '("child", GtkA.ContainerChildPropertyInfo), '("composite-child", GtkA.WidgetCompositeChildPropertyInfo), '("double-buffered", GtkA.WidgetDoubleBufferedPropertyInfo), '("editable", WebViewEditablePropertyInfo), '("estimated-load-progress", WebViewEstimatedLoadProgressPropertyInfo), '("events", GtkA.WidgetEventsPropertyInfo), '("expand", GtkA.WidgetExpandPropertyInfo), '("favicon", WebViewFaviconPropertyInfo), '("halign", GtkA.WidgetHalignPropertyInfo), '("has-default", GtkA.WidgetHasDefaultPropertyInfo), '("has-focus", GtkA.WidgetHasFocusPropertyInfo), '("has-tooltip", GtkA.WidgetHasTooltipPropertyInfo), '("height-request", GtkA.WidgetHeightRequestPropertyInfo), '("hexpand", GtkA.WidgetHexpandPropertyInfo), '("hexpand-set", GtkA.WidgetHexpandSetPropertyInfo), '("is-focus", GtkA.WidgetIsFocusPropertyInfo), '("is-loading", WebViewIsLoadingPropertyInfo), '("is-playing-audio", WebViewIsPlayingAudioPropertyInfo), '("margin", GtkA.WidgetMarginPropertyInfo), '("margin-bottom", GtkA.WidgetMarginBottomPropertyInfo), '("margin-end", GtkA.WidgetMarginEndPropertyInfo), '("margin-left", GtkA.WidgetMarginLeftPropertyInfo), '("margin-right", GtkA.WidgetMarginRightPropertyInfo), '("margin-start", GtkA.WidgetMarginStartPropertyInfo), '("margin-top", GtkA.WidgetMarginTopPropertyInfo), '("name", GtkA.WidgetNamePropertyInfo), '("no-show-all", GtkA.WidgetNoShowAllPropertyInfo), '("opacity", GtkA.WidgetOpacityPropertyInfo), '("parent", GtkA.WidgetParentPropertyInfo), '("receives-default", GtkA.WidgetReceivesDefaultPropertyInfo), '("related-view", WebViewRelatedViewPropertyInfo), '("resize-mode", GtkA.ContainerResizeModePropertyInfo), '("scale-factor", GtkA.WidgetScaleFactorPropertyInfo), '("sensitive", GtkA.WidgetSensitivePropertyInfo), '("settings", WebViewSettingsPropertyInfo), '("style", GtkA.WidgetStylePropertyInfo), '("title", WebViewTitlePropertyInfo), '("tooltip-markup", GtkA.WidgetTooltipMarkupPropertyInfo), '("tooltip-text", GtkA.WidgetTooltipTextPropertyInfo), '("uri", WebViewUriPropertyInfo), '("user-content-manager", WebViewUserContentManagerPropertyInfo), '("valign", GtkA.WidgetValignPropertyInfo), '("vexpand", GtkA.WidgetVexpandPropertyInfo), '("vexpand-set", GtkA.WidgetVexpandSetPropertyInfo), '("visible", GtkA.WidgetVisiblePropertyInfo), '("web-context", WebViewWebContextPropertyInfo), '("width-request", GtkA.WidgetWidthRequestPropertyInfo), '("window", GtkA.WidgetWindowPropertyInfo), '("zoom-level", WebViewZoomLevelPropertyInfo)]

type instance AttributeList WebViewBase = '[ '("app-paintable", GtkA.WidgetAppPaintablePropertyInfo), '("border-width", GtkA.ContainerBorderWidthPropertyInfo), '("can-default", GtkA.WidgetCanDefaultPropertyInfo), '("can-focus", GtkA.WidgetCanFocusPropertyInfo), '("child", GtkA.ContainerChildPropertyInfo), '("composite-child", GtkA.WidgetCompositeChildPropertyInfo), '("double-buffered", GtkA.WidgetDoubleBufferedPropertyInfo), '("events", GtkA.WidgetEventsPropertyInfo), '("expand", GtkA.WidgetExpandPropertyInfo), '("halign", GtkA.WidgetHalignPropertyInfo), '("has-default", GtkA.WidgetHasDefaultPropertyInfo), '("has-focus", GtkA.WidgetHasFocusPropertyInfo), '("has-tooltip", GtkA.WidgetHasTooltipPropertyInfo), '("height-request", GtkA.WidgetHeightRequestPropertyInfo), '("hexpand", GtkA.WidgetHexpandPropertyInfo), '("hexpand-set", GtkA.WidgetHexpandSetPropertyInfo), '("is-focus", GtkA.WidgetIsFocusPropertyInfo), '("margin", GtkA.WidgetMarginPropertyInfo), '("margin-bottom", GtkA.WidgetMarginBottomPropertyInfo), '("margin-end", GtkA.WidgetMarginEndPropertyInfo), '("margin-left", GtkA.WidgetMarginLeftPropertyInfo), '("margin-right", GtkA.WidgetMarginRightPropertyInfo), '("margin-start", GtkA.WidgetMarginStartPropertyInfo), '("margin-top", GtkA.WidgetMarginTopPropertyInfo), '("name", GtkA.WidgetNamePropertyInfo), '("no-show-all", GtkA.WidgetNoShowAllPropertyInfo), '("opacity", GtkA.WidgetOpacityPropertyInfo), '("parent", GtkA.WidgetParentPropertyInfo), '("receives-default", GtkA.WidgetReceivesDefaultPropertyInfo), '("resize-mode", GtkA.ContainerResizeModePropertyInfo), '("scale-factor", GtkA.WidgetScaleFactorPropertyInfo), '("sensitive", GtkA.WidgetSensitivePropertyInfo), '("style", GtkA.WidgetStylePropertyInfo), '("tooltip-markup", GtkA.WidgetTooltipMarkupPropertyInfo), '("tooltip-text", GtkA.WidgetTooltipTextPropertyInfo), '("valign", GtkA.WidgetValignPropertyInfo), '("vexpand", GtkA.WidgetVexpandPropertyInfo), '("vexpand-set", GtkA.WidgetVexpandSetPropertyInfo), '("visible", GtkA.WidgetVisiblePropertyInfo), '("width-request", GtkA.WidgetWidthRequestPropertyInfo), '("window", GtkA.WidgetWindowPropertyInfo)]

-- VVV Prop "base-cache-directory"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getWebsiteDataManagerBaseCacheDirectory :: (MonadIO m, WebsiteDataManagerK o) => o -> m T.Text
getWebsiteDataManagerBaseCacheDirectory obj = liftIO $ getObjectPropertyString obj "base-cache-directory"

constructWebsiteDataManagerBaseCacheDirectory :: T.Text -> IO ([Char], GValue)
constructWebsiteDataManagerBaseCacheDirectory val = constructObjectPropertyString "base-cache-directory" val

data WebsiteDataManagerBaseCacheDirectoryPropertyInfo
instance AttrInfo WebsiteDataManagerBaseCacheDirectoryPropertyInfo where
    type AttrAllowedOps WebsiteDataManagerBaseCacheDirectoryPropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint WebsiteDataManagerBaseCacheDirectoryPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint WebsiteDataManagerBaseCacheDirectoryPropertyInfo = WebsiteDataManagerK
    type AttrGetType WebsiteDataManagerBaseCacheDirectoryPropertyInfo = T.Text
    type AttrLabel WebsiteDataManagerBaseCacheDirectoryPropertyInfo = "WebsiteDataManager::base-cache-directory"
    attrGet _ = getWebsiteDataManagerBaseCacheDirectory
    attrSet _ = undefined
    attrConstruct _ = constructWebsiteDataManagerBaseCacheDirectory

-- VVV Prop "base-data-directory"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getWebsiteDataManagerBaseDataDirectory :: (MonadIO m, WebsiteDataManagerK o) => o -> m T.Text
getWebsiteDataManagerBaseDataDirectory obj = liftIO $ getObjectPropertyString obj "base-data-directory"

constructWebsiteDataManagerBaseDataDirectory :: T.Text -> IO ([Char], GValue)
constructWebsiteDataManagerBaseDataDirectory val = constructObjectPropertyString "base-data-directory" val

data WebsiteDataManagerBaseDataDirectoryPropertyInfo
instance AttrInfo WebsiteDataManagerBaseDataDirectoryPropertyInfo where
    type AttrAllowedOps WebsiteDataManagerBaseDataDirectoryPropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint WebsiteDataManagerBaseDataDirectoryPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint WebsiteDataManagerBaseDataDirectoryPropertyInfo = WebsiteDataManagerK
    type AttrGetType WebsiteDataManagerBaseDataDirectoryPropertyInfo = T.Text
    type AttrLabel WebsiteDataManagerBaseDataDirectoryPropertyInfo = "WebsiteDataManager::base-data-directory"
    attrGet _ = getWebsiteDataManagerBaseDataDirectory
    attrSet _ = undefined
    attrConstruct _ = constructWebsiteDataManagerBaseDataDirectory

-- VVV Prop "disk-cache-directory"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getWebsiteDataManagerDiskCacheDirectory :: (MonadIO m, WebsiteDataManagerK o) => o -> m T.Text
getWebsiteDataManagerDiskCacheDirectory obj = liftIO $ getObjectPropertyString obj "disk-cache-directory"

constructWebsiteDataManagerDiskCacheDirectory :: T.Text -> IO ([Char], GValue)
constructWebsiteDataManagerDiskCacheDirectory val = constructObjectPropertyString "disk-cache-directory" val

data WebsiteDataManagerDiskCacheDirectoryPropertyInfo
instance AttrInfo WebsiteDataManagerDiskCacheDirectoryPropertyInfo where
    type AttrAllowedOps WebsiteDataManagerDiskCacheDirectoryPropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint WebsiteDataManagerDiskCacheDirectoryPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint WebsiteDataManagerDiskCacheDirectoryPropertyInfo = WebsiteDataManagerK
    type AttrGetType WebsiteDataManagerDiskCacheDirectoryPropertyInfo = T.Text
    type AttrLabel WebsiteDataManagerDiskCacheDirectoryPropertyInfo = "WebsiteDataManager::disk-cache-directory"
    attrGet _ = getWebsiteDataManagerDiskCacheDirectory
    attrSet _ = undefined
    attrConstruct _ = constructWebsiteDataManagerDiskCacheDirectory

-- VVV Prop "indexeddb-directory"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getWebsiteDataManagerIndexeddbDirectory :: (MonadIO m, WebsiteDataManagerK o) => o -> m T.Text
getWebsiteDataManagerIndexeddbDirectory obj = liftIO $ getObjectPropertyString obj "indexeddb-directory"

constructWebsiteDataManagerIndexeddbDirectory :: T.Text -> IO ([Char], GValue)
constructWebsiteDataManagerIndexeddbDirectory val = constructObjectPropertyString "indexeddb-directory" val

data WebsiteDataManagerIndexeddbDirectoryPropertyInfo
instance AttrInfo WebsiteDataManagerIndexeddbDirectoryPropertyInfo where
    type AttrAllowedOps WebsiteDataManagerIndexeddbDirectoryPropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint WebsiteDataManagerIndexeddbDirectoryPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint WebsiteDataManagerIndexeddbDirectoryPropertyInfo = WebsiteDataManagerK
    type AttrGetType WebsiteDataManagerIndexeddbDirectoryPropertyInfo = T.Text
    type AttrLabel WebsiteDataManagerIndexeddbDirectoryPropertyInfo = "WebsiteDataManager::indexeddb-directory"
    attrGet _ = getWebsiteDataManagerIndexeddbDirectory
    attrSet _ = undefined
    attrConstruct _ = constructWebsiteDataManagerIndexeddbDirectory

-- VVV Prop "local-storage-directory"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getWebsiteDataManagerLocalStorageDirectory :: (MonadIO m, WebsiteDataManagerK o) => o -> m T.Text
getWebsiteDataManagerLocalStorageDirectory obj = liftIO $ getObjectPropertyString obj "local-storage-directory"

constructWebsiteDataManagerLocalStorageDirectory :: T.Text -> IO ([Char], GValue)
constructWebsiteDataManagerLocalStorageDirectory val = constructObjectPropertyString "local-storage-directory" val

data WebsiteDataManagerLocalStorageDirectoryPropertyInfo
instance AttrInfo WebsiteDataManagerLocalStorageDirectoryPropertyInfo where
    type AttrAllowedOps WebsiteDataManagerLocalStorageDirectoryPropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint WebsiteDataManagerLocalStorageDirectoryPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint WebsiteDataManagerLocalStorageDirectoryPropertyInfo = WebsiteDataManagerK
    type AttrGetType WebsiteDataManagerLocalStorageDirectoryPropertyInfo = T.Text
    type AttrLabel WebsiteDataManagerLocalStorageDirectoryPropertyInfo = "WebsiteDataManager::local-storage-directory"
    attrGet _ = getWebsiteDataManagerLocalStorageDirectory
    attrSet _ = undefined
    attrConstruct _ = constructWebsiteDataManagerLocalStorageDirectory

-- VVV Prop "offline-application-cache-directory"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getWebsiteDataManagerOfflineApplicationCacheDirectory :: (MonadIO m, WebsiteDataManagerK o) => o -> m T.Text
getWebsiteDataManagerOfflineApplicationCacheDirectory obj = liftIO $ getObjectPropertyString obj "offline-application-cache-directory"

constructWebsiteDataManagerOfflineApplicationCacheDirectory :: T.Text -> IO ([Char], GValue)
constructWebsiteDataManagerOfflineApplicationCacheDirectory val = constructObjectPropertyString "offline-application-cache-directory" val

data WebsiteDataManagerOfflineApplicationCacheDirectoryPropertyInfo
instance AttrInfo WebsiteDataManagerOfflineApplicationCacheDirectoryPropertyInfo where
    type AttrAllowedOps WebsiteDataManagerOfflineApplicationCacheDirectoryPropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint WebsiteDataManagerOfflineApplicationCacheDirectoryPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint WebsiteDataManagerOfflineApplicationCacheDirectoryPropertyInfo = WebsiteDataManagerK
    type AttrGetType WebsiteDataManagerOfflineApplicationCacheDirectoryPropertyInfo = T.Text
    type AttrLabel WebsiteDataManagerOfflineApplicationCacheDirectoryPropertyInfo = "WebsiteDataManager::offline-application-cache-directory"
    attrGet _ = getWebsiteDataManagerOfflineApplicationCacheDirectory
    attrSet _ = undefined
    attrConstruct _ = constructWebsiteDataManagerOfflineApplicationCacheDirectory

-- VVV Prop "websql-directory"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getWebsiteDataManagerWebsqlDirectory :: (MonadIO m, WebsiteDataManagerK o) => o -> m T.Text
getWebsiteDataManagerWebsqlDirectory obj = liftIO $ getObjectPropertyString obj "websql-directory"

constructWebsiteDataManagerWebsqlDirectory :: T.Text -> IO ([Char], GValue)
constructWebsiteDataManagerWebsqlDirectory val = constructObjectPropertyString "websql-directory" val

data WebsiteDataManagerWebsqlDirectoryPropertyInfo
instance AttrInfo WebsiteDataManagerWebsqlDirectoryPropertyInfo where
    type AttrAllowedOps WebsiteDataManagerWebsqlDirectoryPropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint WebsiteDataManagerWebsqlDirectoryPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint WebsiteDataManagerWebsqlDirectoryPropertyInfo = WebsiteDataManagerK
    type AttrGetType WebsiteDataManagerWebsqlDirectoryPropertyInfo = T.Text
    type AttrLabel WebsiteDataManagerWebsqlDirectoryPropertyInfo = "WebsiteDataManager::websql-directory"
    attrGet _ = getWebsiteDataManagerWebsqlDirectory
    attrSet _ = undefined
    attrConstruct _ = constructWebsiteDataManagerWebsqlDirectory

type instance AttributeList WebsiteDataManager = '[ '("base-cache-directory", WebsiteDataManagerBaseCacheDirectoryPropertyInfo), '("base-data-directory", WebsiteDataManagerBaseDataDirectoryPropertyInfo), '("disk-cache-directory", WebsiteDataManagerDiskCacheDirectoryPropertyInfo), '("indexeddb-directory", WebsiteDataManagerIndexeddbDirectoryPropertyInfo), '("local-storage-directory", WebsiteDataManagerLocalStorageDirectoryPropertyInfo), '("offline-application-cache-directory", WebsiteDataManagerOfflineApplicationCacheDirectoryPropertyInfo), '("websql-directory", WebsiteDataManagerWebsqlDirectoryPropertyInfo)]

-- VVV Prop "fullscreen"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getWindowPropertiesFullscreen :: (MonadIO m, WindowPropertiesK o) => o -> m Bool
getWindowPropertiesFullscreen obj = liftIO $ getObjectPropertyBool obj "fullscreen"

constructWindowPropertiesFullscreen :: Bool -> IO ([Char], GValue)
constructWindowPropertiesFullscreen val = constructObjectPropertyBool "fullscreen" val

data WindowPropertiesFullscreenPropertyInfo
instance AttrInfo WindowPropertiesFullscreenPropertyInfo where
    type AttrAllowedOps WindowPropertiesFullscreenPropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint WindowPropertiesFullscreenPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint WindowPropertiesFullscreenPropertyInfo = WindowPropertiesK
    type AttrGetType WindowPropertiesFullscreenPropertyInfo = Bool
    type AttrLabel WindowPropertiesFullscreenPropertyInfo = "WindowProperties::fullscreen"
    attrGet _ = getWindowPropertiesFullscreen
    attrSet _ = undefined
    attrConstruct _ = constructWindowPropertiesFullscreen

-- VVV Prop "geometry"
   -- Type: TInterface "Gdk" "Rectangle"
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getWindowPropertiesGeometry :: (MonadIO m, WindowPropertiesK o) => o -> m Gdk.Rectangle
getWindowPropertiesGeometry obj = liftIO $ getObjectPropertyBoxed obj "geometry" Gdk.Rectangle

constructWindowPropertiesGeometry :: Gdk.Rectangle -> IO ([Char], GValue)
constructWindowPropertiesGeometry val = constructObjectPropertyBoxed "geometry" val

data WindowPropertiesGeometryPropertyInfo
instance AttrInfo WindowPropertiesGeometryPropertyInfo where
    type AttrAllowedOps WindowPropertiesGeometryPropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint WindowPropertiesGeometryPropertyInfo = (~) Gdk.Rectangle
    type AttrBaseTypeConstraint WindowPropertiesGeometryPropertyInfo = WindowPropertiesK
    type AttrGetType WindowPropertiesGeometryPropertyInfo = Gdk.Rectangle
    type AttrLabel WindowPropertiesGeometryPropertyInfo = "WindowProperties::geometry"
    attrGet _ = getWindowPropertiesGeometry
    attrSet _ = undefined
    attrConstruct _ = constructWindowPropertiesGeometry

-- VVV Prop "locationbar-visible"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getWindowPropertiesLocationbarVisible :: (MonadIO m, WindowPropertiesK o) => o -> m Bool
getWindowPropertiesLocationbarVisible obj = liftIO $ getObjectPropertyBool obj "locationbar-visible"

constructWindowPropertiesLocationbarVisible :: Bool -> IO ([Char], GValue)
constructWindowPropertiesLocationbarVisible val = constructObjectPropertyBool "locationbar-visible" val

data WindowPropertiesLocationbarVisiblePropertyInfo
instance AttrInfo WindowPropertiesLocationbarVisiblePropertyInfo where
    type AttrAllowedOps WindowPropertiesLocationbarVisiblePropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint WindowPropertiesLocationbarVisiblePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint WindowPropertiesLocationbarVisiblePropertyInfo = WindowPropertiesK
    type AttrGetType WindowPropertiesLocationbarVisiblePropertyInfo = Bool
    type AttrLabel WindowPropertiesLocationbarVisiblePropertyInfo = "WindowProperties::locationbar-visible"
    attrGet _ = getWindowPropertiesLocationbarVisible
    attrSet _ = undefined
    attrConstruct _ = constructWindowPropertiesLocationbarVisible

-- VVV Prop "menubar-visible"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getWindowPropertiesMenubarVisible :: (MonadIO m, WindowPropertiesK o) => o -> m Bool
getWindowPropertiesMenubarVisible obj = liftIO $ getObjectPropertyBool obj "menubar-visible"

constructWindowPropertiesMenubarVisible :: Bool -> IO ([Char], GValue)
constructWindowPropertiesMenubarVisible val = constructObjectPropertyBool "menubar-visible" val

data WindowPropertiesMenubarVisiblePropertyInfo
instance AttrInfo WindowPropertiesMenubarVisiblePropertyInfo where
    type AttrAllowedOps WindowPropertiesMenubarVisiblePropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint WindowPropertiesMenubarVisiblePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint WindowPropertiesMenubarVisiblePropertyInfo = WindowPropertiesK
    type AttrGetType WindowPropertiesMenubarVisiblePropertyInfo = Bool
    type AttrLabel WindowPropertiesMenubarVisiblePropertyInfo = "WindowProperties::menubar-visible"
    attrGet _ = getWindowPropertiesMenubarVisible
    attrSet _ = undefined
    attrConstruct _ = constructWindowPropertiesMenubarVisible

-- VVV Prop "resizable"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getWindowPropertiesResizable :: (MonadIO m, WindowPropertiesK o) => o -> m Bool
getWindowPropertiesResizable obj = liftIO $ getObjectPropertyBool obj "resizable"

constructWindowPropertiesResizable :: Bool -> IO ([Char], GValue)
constructWindowPropertiesResizable val = constructObjectPropertyBool "resizable" val

data WindowPropertiesResizablePropertyInfo
instance AttrInfo WindowPropertiesResizablePropertyInfo where
    type AttrAllowedOps WindowPropertiesResizablePropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint WindowPropertiesResizablePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint WindowPropertiesResizablePropertyInfo = WindowPropertiesK
    type AttrGetType WindowPropertiesResizablePropertyInfo = Bool
    type AttrLabel WindowPropertiesResizablePropertyInfo = "WindowProperties::resizable"
    attrGet _ = getWindowPropertiesResizable
    attrSet _ = undefined
    attrConstruct _ = constructWindowPropertiesResizable

-- VVV Prop "scrollbars-visible"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getWindowPropertiesScrollbarsVisible :: (MonadIO m, WindowPropertiesK o) => o -> m Bool
getWindowPropertiesScrollbarsVisible obj = liftIO $ getObjectPropertyBool obj "scrollbars-visible"

constructWindowPropertiesScrollbarsVisible :: Bool -> IO ([Char], GValue)
constructWindowPropertiesScrollbarsVisible val = constructObjectPropertyBool "scrollbars-visible" val

data WindowPropertiesScrollbarsVisiblePropertyInfo
instance AttrInfo WindowPropertiesScrollbarsVisiblePropertyInfo where
    type AttrAllowedOps WindowPropertiesScrollbarsVisiblePropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint WindowPropertiesScrollbarsVisiblePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint WindowPropertiesScrollbarsVisiblePropertyInfo = WindowPropertiesK
    type AttrGetType WindowPropertiesScrollbarsVisiblePropertyInfo = Bool
    type AttrLabel WindowPropertiesScrollbarsVisiblePropertyInfo = "WindowProperties::scrollbars-visible"
    attrGet _ = getWindowPropertiesScrollbarsVisible
    attrSet _ = undefined
    attrConstruct _ = constructWindowPropertiesScrollbarsVisible

-- VVV Prop "statusbar-visible"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getWindowPropertiesStatusbarVisible :: (MonadIO m, WindowPropertiesK o) => o -> m Bool
getWindowPropertiesStatusbarVisible obj = liftIO $ getObjectPropertyBool obj "statusbar-visible"

constructWindowPropertiesStatusbarVisible :: Bool -> IO ([Char], GValue)
constructWindowPropertiesStatusbarVisible val = constructObjectPropertyBool "statusbar-visible" val

data WindowPropertiesStatusbarVisiblePropertyInfo
instance AttrInfo WindowPropertiesStatusbarVisiblePropertyInfo where
    type AttrAllowedOps WindowPropertiesStatusbarVisiblePropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint WindowPropertiesStatusbarVisiblePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint WindowPropertiesStatusbarVisiblePropertyInfo = WindowPropertiesK
    type AttrGetType WindowPropertiesStatusbarVisiblePropertyInfo = Bool
    type AttrLabel WindowPropertiesStatusbarVisiblePropertyInfo = "WindowProperties::statusbar-visible"
    attrGet _ = getWindowPropertiesStatusbarVisible
    attrSet _ = undefined
    attrConstruct _ = constructWindowPropertiesStatusbarVisible

-- VVV Prop "toolbar-visible"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getWindowPropertiesToolbarVisible :: (MonadIO m, WindowPropertiesK o) => o -> m Bool
getWindowPropertiesToolbarVisible obj = liftIO $ getObjectPropertyBool obj "toolbar-visible"

constructWindowPropertiesToolbarVisible :: Bool -> IO ([Char], GValue)
constructWindowPropertiesToolbarVisible val = constructObjectPropertyBool "toolbar-visible" val

data WindowPropertiesToolbarVisiblePropertyInfo
instance AttrInfo WindowPropertiesToolbarVisiblePropertyInfo where
    type AttrAllowedOps WindowPropertiesToolbarVisiblePropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint WindowPropertiesToolbarVisiblePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint WindowPropertiesToolbarVisiblePropertyInfo = WindowPropertiesK
    type AttrGetType WindowPropertiesToolbarVisiblePropertyInfo = Bool
    type AttrLabel WindowPropertiesToolbarVisiblePropertyInfo = "WindowProperties::toolbar-visible"
    attrGet _ = getWindowPropertiesToolbarVisible
    attrSet _ = undefined
    attrConstruct _ = constructWindowPropertiesToolbarVisible

type instance AttributeList WindowProperties = '[ '("fullscreen", WindowPropertiesFullscreenPropertyInfo), '("geometry", WindowPropertiesGeometryPropertyInfo), '("locationbar-visible", WindowPropertiesLocationbarVisiblePropertyInfo), '("menubar-visible", WindowPropertiesMenubarVisiblePropertyInfo), '("resizable", WindowPropertiesResizablePropertyInfo), '("scrollbars-visible", WindowPropertiesScrollbarsVisiblePropertyInfo), '("statusbar-visible", WindowPropertiesStatusbarVisiblePropertyInfo), '("toolbar-visible", WindowPropertiesToolbarVisiblePropertyInfo)]

